/*
TASK: boxes
LANG: C++
*/
#include <iostream>
#include <vector>
#include <cstring>

using namespace std;

int n;
vector <int> r[100001];
int rr[100001];
int used[100001];
int u2[100001];
int zad[100001];
int br;

void dfs(int v)
{
	used[v]=1;
	for(int i=0;i<r[v].size();i++) if(used[r[v][i]]==0) dfs(r[v][i]);
}

void solve()
{
	int x;
	for(int i=1;i<=n;i++)
	{
		if(!zad[i]&&used[i]==0)
		{
			x=i;
			while(u2[x]==0){u2[x]=1;x=rr[x];}	
			br++;
			dfs(x);
		}
	}
	for(int i=1;i<=n;i++)
	{
		if(used[i]==0) {br++;dfs(i);}
	}
}



void read()
{
	int x;
	scanf("%d",&n);
	for(int i=1;i<=n;i++)
	{
		scanf("%d",&x);
		r[x].push_back(i);
		rr[i]=x;
		zad[x]++;
	}
	solve();
}

int main()
{
	int fa,sa;
	read();
	fa=br;
	memset(used,0,sizeof(used));
	memset(u2,0,sizeof(u2));
	memset(rr,0,sizeof(rr));
	memset(zad,0,sizeof(zad));
	br=0;
	for(int i=0;i<=n;i++) r[i].clear();
	read();
	sa=br;
	printf("%d %d\n",fa,sa);
	return 0;
}
