/*
TASK: boxes
LANG: C++
*/
#include <cstdio>
#include <vector>
using namespace std;

int p[110000];
int previs[110000], vis[110000];
vector<int> t[110000];
int n;

void init()
{
	int i;
	for(i=0; i<110000; i++) { t[i].resize(0); previs[i]=vis[i]=0; }
	
	scanf("%d", &n);
	for(i=1; i<=n; i++) { scanf("%d", &p[i]); t[p[i]].push_back(i); }
}

void dfs(int i)
{
	//printf("%d\n", i);
	vis[i]=1;
	for(unsigned j=0; j<t[i].size(); j++) if(!vis[t[i][j]]) dfs(t[i][j]);
}

void predfs(int i)
{
	//printf("\n\nPredfs(%d)\n", i);
	while(!previs[i]) { previs[i]=1; i=p[i]; }
	dfs(i);
}

void solve(char after)
{
	init();
	int br=0;
	for(int i=1; i<=n; i++) if(!vis[i]) { br++; predfs(i); }
	printf("%d%c", br, after);
}

int main()
{
	solve(' ');
	solve('\n');
}
