/*
TASK:titanic
LANG:C++
*/
#include <iostream>
using namespace std;
int n, m;

bool asked[1024][1024];
int opa[1024][1024];

int nx[] = {0, 0 ,+1 , -1};
int ny[] = {+1, -1, 0, 0};

bool ok(int x, int y)
{
	return !( x < 0 || x >=n || y< 0 || y>=m );
}

int ask (int x, int y)
{
	
	if (asked[x][y]) return opa[x][y];
	asked[x][y] = 1;
	printf("0 %d %d\n", x, y); 
	scanf ("%d", &opa[x][y]);
	return opa [x][y];

}


int main ()
{
	
	scanf ("%d%d", &n, &m);
	
	int x = 0, y = 0;
	if (ask(0, m-1) > ask (x, y)) {x = 0; y = m-1;}
	if (ask(n-1, m-1) > ask (x, y)) {x = n-1; y = m-1;}
	if (ask(n-1, 0) > ask (x, y)) {x = n-1; y = 0;}
	if (ask(n/2, m/2) > ask (x, y)) {x = n/2; y = m/2;}
	
	
	
	while (1)
	{
		int MIN = ask(x, y);
		int now = MIN;
		int next = -1;
		int i;
		for (i = 0; i<4; i++)
		{
			if (ok(x + nx[i], y + ny[i]))
			{
				if (ask (x + nx[i], y + ny[i]) > MIN) {MIN = ask (x + nx[i], y + ny[i]); next = i; } 
			}
		}
		 	
		if (MIN == now) {printf ("1 %d %d\n", x, y); break;}
		else
		{
			x = x + nx[next];
			y = y + ny[next];
		}
		
	}
	
	
return 0;
}