/*
TASK:msweeper
LANG:C++
*/
#include<iostream>
#include<algorithm>
#include<stack>
#include<math.h>
#define pii pair <int,int>
#define MAXN 10002
#define DET(a,b,c) a.first*(b.second-c.second)+b.first*(c.second-a.second)+c.first*(a.second-b.second)
#define DIST(a,b) (a.first-b.first)*(a.first-b.first)+(a.second-b.second)*(a.second-b.second)
using namespace std;
int n,r;
double ans=0;
pii all[MAXN];
stack <pii> s;
bool cmp(pii a,pii b);
void init();
void GS();
int main()
{
 init();
 pii tmp;
 ans=M_PI*r*2;
 if(n==1){printf("%lf\n",ans);return 0;}
 if(n==2){ans+=sqrt(DIST(all[0],all[1]));printf("%lf\n",ans);return 0;}
 ans=M_PI*r*2;
 GS();
 tmp=s.top();
 s.pop();
 while(!s.empty())
 {
//  printf("%d %d , %d %d\n",tmp.first,tmp.second,s.top().first,s.top().second);
  ans+=sqrt(DIST(tmp,s.top()));
  tmp=s.top();
  s.pop();
 }
 printf("%lf\n",ans);
 return 0;
}
void init()
{
 pii tmp,min;
 int mini;
 min.first=300000;
 min.second=300000;
 
 scanf("%d%d",&n,&r);
 for(int i=0;i<n;i++)
 {
  scanf("%d%d",&tmp.first,&tmp.second);
  if(tmp.first<min.first){min=tmp;mini=i;}
  if(tmp.first==min.first && tmp.second<min.second){min=tmp;mini=i;}
  all[i]=tmp;
 }
 
 tmp=all[0];
 all[0]=all[mini];
 all[mini]=tmp;
 sort(all+1,all+n,cmp);
 all[n]=all[0];
 return;     
}
bool cmp(pii a,pii b)
{
 if(DET(a,b,all[0])>0)return true;
 if(DET(a,b,all[0])==0)
  if(DIST(a,all[0])>DIST(b,all[0]))return true;
  return false;
}
void GS()
{
 int i;
 pii tmp1,tmp2;
 s.push(all[0]);
 s.push(all[1]);
 for(i=2;i<=n;i++)
 {
  tmp2=s.top();
  s.pop();
  tmp1=s.top();
  s.pop();
//  printf("%d %d , %d %d , %d %d ,  det=%d\n",tmp1.first,tmp1.second,tmp2.first,tmp2.second,all[i].first,all[i].second,DET(tmp1,tmp2,all[i]));
  if(DET(tmp1,tmp2,all[i])>0)
  {
   s.push(tmp1);
   s.push(tmp2);
   s.push(all[i]);
  }
  else if(DET(tmp1,tmp2,all[i])==0)
  {
   s.push(tmp1);
   if(DIST(tmp1,tmp2)>DIST(tmp1,all[i]))s.push(tmp2);
   else s.push(all[i]);
  }
  else {s.push(tmp1);i--;}
 }
 return; 
}
