/*
TASK: titanic
LANG: C++
*/

#include <cstdio>
#include <cstdlib>
#include <climits>

const int MAX_N = 1000 + 5;

const int dx[] = {-1, 0, 0, 1};
const int dy[] = {0, -1, 1, 0};

int N, M;
int h[MAX_N][MAX_N];
bool ok[MAX_N][MAX_N];

inline int find(int x, int y)
{
	if(ok[x][y])	return h[x][y];
	printf("0 %d %d\n", x, y);
	scanf("%d", &h[x][y]);
	ok[x][y] = 1;
	return h[x][y];
}

bool check(int &x, int &y)
{
	int cur = find(x, y);
	if(cur == INT_MAX)	return 1;
	int mx = INT_MIN;
	int ind = -1;
	for(int i = 0; i < 4; i ++)
		if( x + dx[i] >= 0 && x + dx[i] < N && y + dy[i] >= 0 && y + dy[i] < M)
		{
			int val = find(x + dx[i], y + dy[i]);
			if(val > mx)	mx = val, ind = i;
		}
	if( cur > mx )	return 1;
	x = x + dx[ind];
	y = y + dy[ind];
	return 0;
}

int main()
{
	scanf("%d %d", &N, &M);
	srand(M * N);
//	int x = rand() % N;
//	int y = rand() % M;
	int x = N >> 1, y = M >> 1;
	while( !check(x, y) );
	printf("1 %d %d\n", x, y);
	return 0;
}
