/*
TASK: titanic
LANG: C++
*/

// #include <iostream>
#include <cstdio>
#include <queue>
#include <climits>

#define ii pair<int, int>

using namespace std;

int map[1024][1024];
int used[1024][1024];

int main() {
  
  int n, m;
  scanf("%d %d", &n, &m);
  
  for(int i=0;i<100; i++) {
    map[i][0] = map[0][i] = map[i][m+1] = map[n+1][i] = -INT_MAX;
    used[i][0] = used[0][i] = used[i][m+1] = used[n+1][i] = true;
  }
  
  queue<ii> q;
  q.push(ii(1,1));
  
  printf("0 %d %d\n", 0, 0);
  scanf("%d", &map[1][1]);
  
  while(q.size()) {
    ii curr = q.front();
    q.pop();
    
    used[curr.first][curr.second] = true;
    
    if(!used[curr.first-1][curr.second]) {
      printf("0 %d %d\n", curr.first-2, curr.second-1);
      scanf("%d", &map[curr.first-1][curr.second]);
      used[curr.first-1][curr.second] = true;
      q.push(ii(curr.first-1,curr.second));
    }
    
    if(!used[curr.first+1][curr.second]) {
      printf("0 %d %d\n", curr.first, curr.second-1);
      scanf("%d", &map[curr.first+1][curr.second]);
      used[curr.first+1][curr.second] = true;
      q.push(ii(curr.first+1,curr.second));
    }
    
    if(!used[curr.first][curr.second-1]) {
      printf("0 %d %d\n", curr.first-1, curr.second-2);
      scanf("%d", &map[curr.first][curr.second-1]);
      used[curr.first][curr.second-1] = true;
      q.push(ii(curr.first,curr.second-1));
    }
    
    if(!used[curr.first][curr.second+1]) {
      printf("0 %d %d\n", curr.first-1, curr.second);
      scanf("%d", &map[curr.first][curr.second+1]);
      used[curr.first][curr.second+1] = true;
      q.push(ii(curr.first,curr.second+1));
    }
    
//     cout<<endl;
//     for(int i=0; i<=n+1; i++) {
//       for(int j=0;j<=m+1;j++)
//       if(map[i][j] > -INT_MAX) 
//           cout<<map[i][j]<<" ";
//       else
//         cout<<"~ ";
//       printf("\n");
//     }
//     cout<<endl;
    
    int cm = map[curr.first][curr.second];
    
    if(cm > map[curr.first-1][curr.second] && used[curr.first-1][curr.second] &&
       cm > map[curr.first+1][curr.second] && used[curr.first+1][curr.second] &&
       cm > map[curr.first][curr.second-1] && used[curr.first][curr.second-1] &&
       cm > map[curr.first][curr.second+1] && used[curr.first][curr.second+1]
      ) {
      
      
      
      printf("1 %d %d\n", curr.first-1, curr.second-1);
      return 0;
    }
  }
  
  return 0;
}
