/*
TASK:boxes
LANG:C++
*/

#include <iostream>
#include <stdlib.h>
#include <deque>
using namespace std;

int a[100001];
bool used[100001]={0};
int n;
deque<int> st;

int longest(int f)
{
    if(used[f])return 0;
    int i,j=1;
    used[f]=1;
    st.push_front(f);
    for(i=1;i<=n;i++)if(!used[i]&&a[i]==f)j+=longest(i);
    used[st[0]]=0;
    st.pop_front();
    return j;
}

int findlongest()
{
    int i,j,m,J=0,M=0;
    for(i=1;i<=n;i++)
    {
     m=longest(i);
     if(m>M){J=i;M=m;}
    }
    return J;
}

int remove(int f)
{
    int i,j=1;
    used[f]=1;
    for(i=1;i<=n;i++)if(!used[i]&&a[i]==f)j+=remove(i);
    return j;
}

int crashes()
{
    int i=0,j,m=n;
    while(m)
    {
     i++;
     j=findlongest();
     m-=remove(j);
    };
    return i;
}

int main()
{
    int N,p,i,m[2];
    for(N=1;N>=0;N--){                    
    cin>>n;
    for(i=1;i<=n;i++)cin>>a[i];
    m[N]=crashes();
    memset(used,0,sizeof(int));
    }
    cout<<m[1]<<' '<<m[0]<<endl;
    return 0;
}
