/*
TASK: msweeper
LANG: C++
*/

#include<cstdio>
#include<algorithm>
#include<cmath>

#define M_PI 3.14159265358979323846

struct pnt {int x,y;void read() {scanf("%d%d",&x,&y);}void print() {printf("%d %d\n",x,y);}};

int ccw(pnt p0, pnt p1, pnt p2) {return (p1.x-p0.x)*(p2.y-p0.y)-(p2.x-p0.x)*(p1.y-p0.y);}

int n,r;
pnt pnts[10007];
int obv [10007],obv_pnts=0;
int stack[10007],top=0;


bool cmp(int a, int b) {
	int s=ccw(pnts[obv[0]],pnts[a],pnts[b]);
	if (s==0) {
		int d1=(pnts[obv[0]].x-pnts[a].x)*(pnts[obv[0]].x-pnts[a].x)+(pnts[obv[0]].y-pnts[a].y)*(pnts[obv[0]].y-pnts[a].y);
		int d2=(pnts[obv[0]].x-pnts[b].x)*(pnts[obv[0]].x-pnts[b].x)+(pnts[obv[0]].y-pnts[b].y)*(pnts[obv[0]].y-pnts[b].y);
		return d1<d2;
	}
	return s>0;
}

void obvi() {
	for(int i=0;i<n;++i) obv[i]=i;
	int ind_low=0;
	for(int i=1;i<n;++i) {
		if((pnts[i].x<pnts[ind_low].x)||(pnts[i].x==pnts[ind_low].x&&pnts[i].y<pnts[ind_low].y)) ind_low=i;
	}

	std::swap(obv[0],obv[ind_low]);
	std::sort(obv+1,obv+n,cmp);
	
	obv[n]=obv[0];
	stack[0]=obv[0];stack[1]=obv[1];
	top=2;
	for(int i=2;i<=n;++i) {
		while(ccw(pnts[stack[top-2]],pnts[stack[top-1]],pnts[obv[i]])<0) --top;
		stack[top++]=obv[i];
	}
	
}

double len=0,c;

void calc() {
	c=2*r*M_PI;
	
	for(int i=0;i<top-1;++i) len+=hypot(pnts[stack[i]].x-pnts[stack[i+1]].x,pnts[stack[i]].y-pnts[stack[i+1]].y);
	
	len+=c;

}

int main() {
	scanf("%d%d",&n,&r);
	for(int i=0;i<n;++i) pnts[i].read();

if(n==1) {
	printf("%lf\n",M_PI*2*r);
	return 0;	
}
if(n==2) {
	printf("%lf\n",M_PI*2*r+2*hypot(pnts[0].x-pnts[1].x,pnts[0].y-pnts[1].y));
	return 0;	
}
	
	obvi();
	
	calc();
	printf("%lf\n",len);
	return 0;
}
