/*
TASK: boxes
LANG: C++
*/

#include <iostream>
#include <vector>
using namespace std;

int n;
int kv[100020];
vector<int> kot[100020];
bool visit[100020];
int br = 0;

void markv( int i )
{
     visit[i] = 1;
     for ( int j = 0; j < kot[i].size(); j++ )
     {
         if ( visit[kot[i][j]] == 0 )
            markv( kot[i][j] );
     }
}

int solve()
{
    int i, j;
    int sol = 0;
    vector<int> mar;

    memset( visit, 0, sizeof( visit ) );
    
    for ( i = 1; i <= n; i++ )
    {
        if ( visit[i] == 0 )
        {
             visit[i] = 1;
             j = i;
             mar.clear();
             while ( ( visit[kv[j]] == 0 ) && ( kv[j] != j ) )
             {
//                   cout << i << " " << j << " " << kv[j] << endl;
                   visit[j] = 1;
                   mar.push_back( j );
                   j = kv[j];
             }
             sol++;
             visit[j] = 1;
             mar.push_back( j );
             for ( j = 0; j < mar.size(); j++ )
                 markv( mar[j] );
        }
    }
    
    return sol;
}

int main()
{
    int i, j;
    
    cin >> n;
    memset( kv, 0, sizeof( kv ) );
    memset( kot, 0, sizeof( kot ) );
    for ( i = 1; i <= n; i++ )
    {
        scanf( "%d", &kv[i] );
        kot[kv[i]].push_back( i );
    }
    
    cout << solve() << " ";

    cin >> n;
    memset( kv, 0, sizeof( kv ) );
    memset( kot, 0, sizeof( kot ) );
    for ( i = 1; i <= n; i++ )
    {
        scanf( "%d", &kv[i] );
        kot[kv[i]].push_back( i );
    }

    cout << solve() << endl;
    return 0;
}
