/*
TASK: boxes
LANG: C++
*/

#include <cstdio>
#include <cstring>


int prev[131072];
int opened[131072];

int open(int v, int n) {
	while(true) {
		opened[v] = n;

		v = prev[v];
		if(opened[v]) {
			return opened[v] == n;
		}
	}
}

void do_test() {
	memset(opened, 0, sizeof(opened));

	int n, lnk;
	scanf("%d", &n);
	for(int i = 0; i < n; ++i) {
		scanf("%d", &lnk); --lnk;
		prev[i] = lnk;
	}

	int broken = 0;
	for(int i = 0; i < n; ++i) {
		if(!opened[i]) {
			broken += open(i, i+1);
		}
	}
	printf("%d", broken);
}

int main() {
	do_test();
	printf(" ");
	do_test();
	printf("\n");
	return 0;
}
