/*
TASK: msweeper
LANG: C++
*/
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <vector>
#include <iostream>
#define sz(a) ((int)a.size())
#define SQR(x) (x)*(x)
using namespace std;

struct point{ int x, y; 
       point(){}
       point( int _x, int _y ) { x=_x; y=_y; }
};

int N, R;
point p[16384];
vector< point > ans, rans;
// ans - temp
// rans - real
double res;

bool cmp( point p1, point p2 ){
          return p1.y/(double)p1.x < p2.y/(double)p2.x;
     }

inline int vect( int a1, int a2, int b1, int b2 ){ return a1*b2-a2*b1; }

int main(){
    scanf ("%d%d",&N,&R);
    if( N==1 ){ cout<<2*M_PI*R<<endl; exit(0); }
    res = 0.;
    int min_x = 50000;
    int min_y = 50000;
    for(int i=0; i<N; ++i){
            scanf ("%d%d",&p[i].x,&p[i].y);
            //p[i].x+=20001; p[i].y+=20001;
            if( p[i].x*p[i].x + p[i].y*p[i].y < min_x*min_x+min_y*min_y ) { min_x=p[i].x; min_y=p[i].y; }
            // later add +20001 ! ! !
//            printf("%d %d\n",p[i].x,p[i].y);
            }
//    printf ("start at (%d %d)\n",min_x,min_y);
    ans.push_back( point(min_x,min_y) ); 
    for(int i=0; i<N; ++i)
     if(p[i].x!=min_x || p[i].y!=min_y) ans.push_back( point(p[i].x,p[i].y) ); 
    sort ( ans.begin()+1 , ans.end() , cmp );
    ans.push_back ( ans[0] );
    /*
    for(int i=0; i<ans.size(); ++i){
            printf ("%d %d\n",ans[i].x,ans[i].y);
            }
    */
    rans.push_back ( ans[0] );
    rans.push_back ( ans[1] );
    for(int i=2; i<ans.size()-1; ++i){
            int a1 = rans[sz(rans)-1].x - rans[sz(rans)-2].x;
            int a2 = rans[sz(rans)-1].y - rans[sz(rans)-2].y;
            int b1 = ans[i].x - rans[sz(rans)-1].x;
            int b2 = ans[i].y - rans[sz(rans)-1].y;
//            cout << ans[i].x <<" "<<ans[i].y<<" "<<vect(a1,a2,b1,b2)<<" after: ";
            while( vect(a1,a2,b1,b2)<0 ){
                   rans.pop_back();
                   a1 = rans[sz(rans)-1].x - rans[sz(rans)-2].x;
                   a2 = rans[sz(rans)-1].y - rans[sz(rans)-2].y;
                   b1 = ans[i].x - rans[sz(rans)-1].x;
                   b2 = ans[i].y - rans[sz(rans)-1].y;
                   }
//            cout<<rans[sz(rans)-1].x<<" "<<rans[sz(rans)-1].y<<endl;
            rans.push_back( ans[i] );
            }
//   for(int i=0; i<rans.size(); ++i ) cout<<rans[i].x << " "<<rans[i].y<<endl;
     for(int i=0; i<rans.size()-1; ++i) { res += sqrt( SQR(rans[i].x-rans[i+1].x)+SQR(rans[i].y-rans[i+1].y) ); }// printf("(%d %d) to (%d %d) -> %lf\n",rans[i].x,rans[i].y,rans[i+1].x,rans[i+1].y,sqrt( SQR(rans[i].x-rans[i+1].x)+SQR(rans[i].y-rans[i+1].y) )); }
     res += sqrt( SQR(rans[sz(rans)-1].x-rans[0].x)+SQR(rans[sz(rans)-1].y-rans[0].y) );
     res += 2*M_PI*R;
     cout<<res<<endl;
     
}
