/*
TASK: titanic
LANG: C++
*/
#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

const int K = 3050;
const int MAX_N = 1024;

int N, M,c;
int a[MAX_N][MAX_N];
bool used[MAX_N][MAX_N];
int dx[]={-1,0,+1,0};
int dy[]={0,+1,0,-1};
int maxx, maxy;

bool isIn(int x, int y){
       if( x>=0 && y>=0 && x<N && y<M ) return true;
       return false;
       }
       
bool isSol(int x, int y){
       for(int i=0; i<4; ++i)
               if(!isIn(x+dx[i],y+dy[i])) continue;
               else if( used[x+dx[i]][y+dy[i]] && a[x][y]<a[x+dx[i]][y+dy[i]] ) return false;
       return true;
       }

void solveXY(int x, int y){
     used[x][y]=1;
     //printf ("(%d %d)\n",x,y);
     //if(isSol(x,y)){ cout<<"1 "<<x<<" "<<y<<endl; exit(0); }
     for(int i=0; i<4; ++i){
             if( isIn(x+dx[i],y+dy[i]) ){
                 if( !used[x+dx[i]][y+dy[i]] ){
                     used[x+dx[i]][y+dy[i]]=1;
                     printf ("0 %d %d\n",x+dx[i],y+dy[i]);
                     scanf("%d",&c); a[x+dx[i]][y+dy[i]]=c;
                     }
                 if( a[x+dx[i]][y+dy[i]] > a[x][y] ){  solveXY(x+dx[i],y+dy[i]); }
                 }
             }
     if(isSol(x,y)){ cout<<"1 "<<x<<" "<<y<<endl; exit(0); }
     }

int main(){
    scanf ("%d%d",&N,&M);
    printf ("0 0 0\n");
    scanf("%d",&c); a[0][0]=c; used[0][0]=1;
    solveXY(0,0);
}
