/*
TASK:boxes
LANG:C++
*/
#include<iostream>
#include<vector>
#include<queue>
#include<cstdio>
using namespace std;
int n,used[100010];
vector <int > a[100010],re[100010],use;
queue <int > q;
void read()
{
     scanf("%d",&n);
     int j;
     for(int i=1;i<=n;i++)
     {
             scanf("%d",&j);
           a[j].push_back(i);
           re[i].clear();
           re[i].push_back(j);
     }
}
int maxs,maxn;
void bfs(int i,int h)
{
     used[i]=1;
     q.push(i);
          maxn=maxs=0;
     while(!q.empty())
     {
                      int u=q.front();
                      q.pop();
                      if(maxs<used[u])
                      {
                                         maxs=used[u];
                                         maxn=u;
                      }
                      if(h==1)use.push_back(u);
                      int k=a[u].size();
                      for(int j=0;j<k;j++)
                      {
                              if(!used[a[u][j]])
                              {
                                                used[a[u][j]]=used[u]+1;
                                                q.push(a[u][j]);
                              }
                      }
     }
}
void bfsre(int i)
{
     used[i]=1;
     q.push(i);
     maxn=maxs=0;
     while(!q.empty())
     {
                      int u=q.front();
                      q.pop();
                      if(maxs<used[u])
                      {
                                         maxs=used[u];
                                         maxn=u;
                      }
                      int k=re[u].size();
                      for(int j=0;j<k;j++)
                      {
                              if(!used[re[u][j]])
                              {
                                                used[re[u][j]]=used[u]+1;
                                                q.push(re[u][j]);
                              }
                      }
     }
}
void solve()
{
     int br=0;
     for(int i=1;i<=n;i++)
     {
             if(a[i].size())
             {
                            memset(used,0,sizeof(used));
                            bfs(i,0);
                            memset(used,0,sizeof(used));
                            bfsre(maxn);
                            memset(used,0,sizeof(used));
                            bfs(maxn,1);
                            int k=use.size();
                            for(int j=0;j<k;j++)
                            {
                                    a[use[j]].clear();
                            }
                            br++;
                            use.clear();
             }
     }
     cout<<br;
}
int main()
{
    read();
    solve();
    cout<<' ';
    read();
    solve();
    cout<<endl;
    return 0;
}
