/*
TASK: titanic
LANG: C++
*/

#include <cstdio>
#include <iostream>

using namespace std;

bool used[1001][1001];
int A[1001][1001];
int n,m;

int dx[]={-1, 0,+1, 0};
int dy[]={ 0,+1, 0,-1};

bool isIn(int i,int j)
{ return i>=0 && i<n && j>=0 && j<m; }

void silly()
{
 int i,j,k;
 for(i=0;i<n;i++)
    for(j=0;j<m;j++)
       {
        printf("0 %d %d\n",i,j);
        scanf("%d",&A[i][j]);
       }
       
 for(i=0;i<n;i++)
   for(j=0;j<m;j++)
      {
       bool answ=1;
       for(k=0;k<4;k++)
          if(isIn(i+dx[k],j+dy[k]) && A[i+dx[k]][j+dy[k]]>A[i][j]) { answ=0; break; }
       if(answ) { printf("1 %d %d\n",i,j); return; }           
      }    
}

void solveRand()
{
 srand(n*m);
 int shots=3050;
 int i,j,k,p;
 
 while(shots--)
 {
  i=rand()%n;
  j=rand()%m;
  
  while(used[i][j]) { i=rand()%n; j=rand()%m; }
  
  printf("0 %d %d\n",i,j);
  scanf("%d",&A[i][j]); used[i][j]=1;
  
   bool answ=1;
   for(k=0;k<4;k++)
       if(isIn(i+dx[k],j+dy[k])) {
                                  if(!used[i+dx[k]][j+dy[k]]) { answ=0; break; }
                                  if(A[i+dx[k]][j+dy[k]]>A[i][j]) { answ=0; break; }
                                 } 
   if(answ) { printf("1 %d %d\n",i,j); return; }      
   
   for(p=0;p<4;p++)
    {
     int ti=i+dx[p];
     int tj=j+dy[p];
     
     bool answ=1;
     for(k=0;k<4;k++)
       if(isIn(ti+dx[k],tj+dy[k])) {
                                  if(!used[ti+dx[k]][tj+dy[k]]) { answ=0; break; }
                                  if(A[ti+dx[k]][tj+dy[k]]>A[ti][tj]) { answ=0; break; }
                                 } 
    if(answ) { printf("1 %d %d\n",ti,tj); return; }             
    }
 }
 
 for(i=0;i<n;i++)
    for(j=0;j<m;j++)
       if(!used[i][j]) { printf("1 %d %d\n",i,j); return; }
 
}

int main()
{
 scanf("%d %d",&n,&m);
 if(n*m<=3050) silly();
 else solveRand();

 return 0;
}
