/*
TASK: msweeper
LANG: c++
*/
#include <iostream>
#include <math.h>
#include <vector>
#define pb push_back
#define S size()
using namespace std;
struct point{int x;int y; double cs;};
int n,r;
vector <point> v,s;
double dist(point a, point b)
{
       return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}
double an(point a, point b, point c)
{
       a.x-=b.x;
       c.x-=b.x;
       a.y-=b.y;
       c.y-=b.y;
       b.x=b.y=0;
       double ang,an1,an2;
       an1=atan2(a.y, a.x)*180.0/3.14159;
       an2=atan2(c.y, c.x)*180.0/3.14159;
       if (an2<0 && an1>0) an2+=360.0;
       ang=(an2-an1);
       return ang;
}
bool cmp(point a, point b)
{
     return a.cs<b.cs;
}
int cros(point a, point b, point c)
{
    int ab[2],ac[2];
    ab[0]=a.x-b.x;
    ab[1]=a.y-b.y;
    ac[0]=c.x-b.x;
    ac[1]=c.y-b.y;
    return (ab[0]*ac[1]-ab[1]*ac[0]);
}  
int main()
{
    scanf("%d%d", &n, &r);
    int i,j,miny=30000,minx=30000,m;
    point a;
    for (i=0; i<n; i++)
    {
        scanf("%d%d", &a.x, &a.y);
        if (a.y==miny && a.x>minx) {m=i; miny=a.y; minx=a.x;}
        if (a.y<miny) {m=i; miny=a.y; minx=a.x;}
        v.pb(a);
    }
    for (i=0; i<n; i++)
     if (i!=m)
     {
              int c1,c2;
              double h;
              c1=v[i].x-v[m].x;
              c2=v[i].y-v[m].y;
              h=sqrt(c1*c1+c2*c2);
              v[i].cs=c1/h;
     }
    v[m].cs=-3;
    sort(v.begin(), v.end(), cmp);
    s.pb(v[0]);
    s.pb(v[1]);
    for (i=2; i<n; i++)
     {
               bool f=false;
               for (j=i+1; j<n; j++)
                if (cros(s.back(), v[i], v[j])<0) {f=true; break;}
               if (f==false) s.pb(v[i]);
     }
    double len=0;
    int ls=s.S;
    for (i=0; i<ls-1; i++)
    {
        len+=sqrt((s[i].x-s[i+1].x)*(s[i].x-s[i+1].x)+(s[i].y-s[i+1].y)*(s[i].y-s[i+1].y));
        if (i>0)
        {
                double ug=an(s[i-1], s[i], s[i+1]);
                ug=180.0-ug;
                len+=(ug/180.0*3.14159*r);
  //              cout << ug/180.0*3.14159 << endl;
        }
    }
    len+=sqrt((s[ls-1].x-s[0].x)*(s[ls-1].x-s[0].x)+(s[ls-1].y-s[0].y)*(s[ls-1].y-s[0].y));
    double ug=an(s[ls-1], s[0], s[1]);
    ug=180.0-ug;
//                    cout << ug/180.0*3.14159 << endl;
    len+=(ug/180.0*3.14159*r);
    ug=an(s[ls-2], s[ls-1], s[0]);
    ug=180.0-ug;
    len+=(ug/180.0*3.14159*r);
    printf("%f\n", len);
    return 0;


}
