/*
TASK:BOXES
LANG:C++
*/
#include <cstdio>
#include <vector>
#define NMAX 100000
#define NO -1
#define YES (NMAX<<2)
int vis[NMAX];
std::vector<int> nxt[NMAX];
int par[NMAX];
int queue[NMAX];
int qs,qe;
#define q_clear {qs=0;qe=0;}
#define q_empty (qe==qs)
#define q_push(val) queue[qe++]=val
#define q_peek queue[qs]
#define q_pop queue[qs++]
int solve(void)
{
	int i,n,a,broken=0,p,j;
	scanf("%d",&n);
	for(i=0;i<n;++i)
		nxt[i].clear();
	for(i=0;i<n;++i)
	{
		scanf("%d",&a);
		nxt[a-1].push_back(i);
		par[i]=a-1;
		vis[i]=NO;
	}
	for(i=0;i<n;++i)
		if(vis[i]==NO)
		{
			++broken;
			q_clear
			a=i;
			while(vis[a]!=i)
			{
				vis[a]=i;
				a=par[a];
			}
			q_push(a);
			while(!q_empty)
			{
				vis[q_peek]=YES;
				for(j=0;j<nxt[q_peek].size();++j)
					if(vis[nxt[q_peek][j]]!=YES)
						q_push(nxt[q_peek][j]);
				q_pop;
			}
		}
	return broken;
}

int main()
{
	int m,i;
	m=solve();
	i=solve();
	printf("%d %d\n",m,i);
	return 0;
}
