/*
TASK:msweeper
LANG:c++
*/

#include <iostream>
#include <cmath>
using namespace std;
typedef struct points
{
       int x;
       int y;
       int index;
};
int stack[10024];
points Z[10024],tmp;
double distSQ(points CV,points VV)
{
       return sqrt((CV.x-VV.x)*(CV.x-VV.x)+(CV.y-VV.y)*(CV.y-VV.y));
}
int dist(points CV,points VV)
{
    return (CV.x-VV.x)*(CV.x-VV.x)+(CV.y-VV.y)*(CV.y-VV.y);
}
int DetD(points B, points A)
{
    int D = Z[0].x*A.y + A.x*B.y + Z[0].y*B.x - Z[0].x*B.y - A.x*Z[0].y - B.x*A.y;
    if(D == 0)
    {
         //printf("By dist %d %d %d %d %d %d\n",Z[0].x,Z[0].y,A.x,A.y,B.x,B.y);
         int distA = dist(Z[0],A);
         int distB = dist(Z[0],B);
         //printf("%d %d\n",distA,distB);
         if(distA >= distB)
         {        
                  //printf("No Swap\n");
                  return 0;
         }
         //printf("SWAP\n");
         return 1;
    }
    return D < 0;
}
int Det(points K,points A, points B)
{
    int D = K.x*A.y + A.x*B.y + K.y*B.x - K.x*B.y - A.x*K.y - B.x*A.y;
    return D;
}

int main()
{
    int N,R,minnx,i;
    scanf("%d %d",&N,&R);
    minnx = 0;
    for(i = 0;i < N;i++)
    {
          scanf("%d %d",&Z[i].x,&Z[i].y);
          if(Z[i].x <= Z[minnx].x)
          {
                    minnx = i;
          }
    }
    tmp.x = Z[0].x;
    tmp.y = Z[0].y;
    Z[0].x = Z[minnx].x;
    Z[0].y = Z[minnx].y;
    Z[minnx].x = tmp.x;
    Z[minnx].y = tmp.y;
    /*for(i = 0;i < N;i++)
    {
          printf("%d %d\n",Z[i].x,Z[i].y);
    }
    printf("Blalvblabal\n");*/
    sort(Z+1,Z+N,DetD);
   /* for(i = 0;i < N;i++)
    {
          printf("%d %d\n",Z[i].x,Z[i].y);
    }
    printf("Blalvblabal\n");*/
    int top = 0;
    stack[0] = 0;
    stack[1] = 1;
    top = 1;
    for(i = 2;i < N;i++)
    {
                  if(Det(Z[stack[top-1]],Z[stack[top]],Z[i]) > 0)
                  {
                     top++;
                     stack[top] = i;
                  }
                  else
                  {
                      while(Det(Z[stack[top-1]],Z[stack[top]],Z[i]) <= 0)
                      {
                       top--;
                      }
                      top++;
                      stack[top] = i;
                  }
    }
    i = 0;
    if(Det(Z[stack[top-1]],Z[stack[top]],Z[i]) > 0)
                  {
                     top++;
                     stack[top] = i;
                  }
                  else
                  {
                      while(Det(Z[stack[top-1]],Z[stack[top]],Z[i]) < 0)
                      {
                       top--;
                      }
                      top++;
                      stack[top] = i;
                  }
    double len = 0;
    for(i = 0;i < top-1;i++)
    {
          len += distSQ(Z[stack[i]],Z[stack[i+1]]);
          //cout << distSQ(Z[stack[i]],Z[stack[i+1]]) << endl;
          //printf("%d %d\n",Z[stack[i]].x,Z[stack[i]].y);
    }
    //cout << len << endl;
    len += distSQ(Z[0],Z[stack[top-1]]);
    //cout << len << endl;
    //cout << distSQ(Z[0],Z[stack[top-1]]) << endl;
    len += (M_PI*2*R);
    cout << len << endl;
}
    
