/*
TASK: boxes
LANG: C++
*/
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <time.h>
#include <iomanip>
using namespace std;
#define DEBUG true
#define SHOW(v) if (DEBUG) cout << #v << " = " << v << endl;
#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define FORB(i,a,b) for(int i = a; i >= b; i--)
#define SHOWV(v) if (DEBUG) for(int tmp = 0; tmp <= v.size() - 1; tmp++) cout << #v << "[" << tmp << "] = " << v[tmp] << endl;
#define ALL(v) (v).start()), ((v).end()
#define SZ size()
#define FORE(v,f) for_each(ALL(v), f);
#define PAUSE if (DEBUG) system("pause");
#define PII pair<int,int>
#define LL long long
#define LD long double 
#define PB push_back
#define VI vector<int>
#define WHERE if (DEBUG) cout << __FUNCTION__ << ":" << __LINE__ << endl;
#define MAXN 131072
int N;
struct box
{
    bool opened; // otvorena li e kutiqta?
    int parent; // kude e kli4a za tazi kutiq?
    VI keys; // koi klu4iove sa v tazi kutiq?
    void clear() { opened = false; parent = 0; keys.clear(); }
} boxes[MAXN];
void do_open_box(int bid)
{
    if(boxes[bid].opened) return;
    //SHOW(bid);
    boxes[bid].opened = true;
    if (!boxes[bid].keys.empty()) FOR(i,0,boxes[bid].keys.SZ-1)
    {
        //cout << bid << " " << boxes[bid].keys[i] << endl;
        do_open_box(boxes[bid].keys[i]);
    }
    boxes[bid].keys.clear();
}
bool visited[MAXN] = {false};
int try_open_box(int bid)
{
    if (visited[bid]) return bid;
    visited[bid] = true;
    int loc = try_open_box(boxes[bid].parent);
    visited[bid] = false;
    return loc;
}
int main()
{
    int tmp;
    int answ[2]; // broi razbiti kutii za 2-ta testa
    FOR(asdf,0,1)
    {
        answ[asdf] = 0;
        cin >> N;
        FOR(i,1,N)
        {
            boxes[i].clear(); // v na4aloto vsi4ki kutii sa zatvoreni
            visited[i] = false;
        }
        FOR(i,1,N)
        {
            cin >> tmp;
            boxes[i].parent = tmp;
            boxes[tmp].keys.PB(i);
        }
        FOR(i,1,N) if(boxes[i].parent == i) // vsi4ki kutii koito sudurjat sobstveniq si kliu4 se otvarqt purvi
        {
            //SHOW(boxes[i].parent);
            do_open_box(i);
            answ[asdf]++;
        }
        FOR(i,1,N) if(!boxes[i].opened) // otvarqme ostanalite neotvoreni kutii
        {
            int tmp = try_open_box(i);
            //SHOW(tmp);
            do_open_box(tmp);
            answ[asdf]++;
        }
    }
    cout << answ[0] << " " << answ[1] << endl;
    //PAUSE;
    return 0;
}
/*
void try_open_box(int i)
{
    if (opened[where
    return try_open_box(where[i]);
}
*/
/*
struct box
{
    bool opened; // otvorena li e kutiqta
    box *parent; // kude e kli4a za tazi kutiq
    vector<box*> keys; // koi klu4iove sa v tazi kutiq
    void open() { do_open(this); }
    void do_open(box *bx)
    {
        if (bx->opened) return;
        bx->opened = true;
        FOR(i,0,bx->keys.SZ-1) do_open(bx->keys[i]);
        bx->keys.clear();
        // BOXES++ ???
    }
    box() { opened = false; parent = NULL; keys.clear(); }
} boxes[MAXN];
int N; // broi na vsi4kite kutii
int opened; // broi otvoreni kutii
int main()
{
    int tmp = 0;
    cin >> N;
    FOR(i,1,N)
    {
        cin >> tmp;
        boxes[i]->parent = boxes[tmp];
    }
    cout << opened;
    PAUSE;
    return 0;
}
/*
void do_open_box(int id)
{   // otvarqne na kutiq id
    if (opened[id]) return;
    opened[id] = true;
    FOR(i, 0, which[id].SZ - 1) do_open_box(id);
    which[id].clear();
    boxes++;
}
void try_open_box(int i)
{
    if (opened[where
    return try_open_box(where[i]);
}
int main()
{
    int tmp;
    int answ[2]; // broi razbiti kutii za 2-ta testa
    FOR(asdf,0,1)
    {
        // v na4aloto vsi4ki kutii sa zatvoreni
        answ[asdf] = 0;
        cin >> N;
        FOR(i,1,N) opened[i] = false; boxes = 0;
        FOR(i,1,N)
        {
            cin >> tmp;
            where[i] = tmp;
            which[tmp].PB(i);
            //if (i == tmp) open_box(i);
        }
        FOR(i,1,N) if(i == where[i])
        {
            do_open_box(i);
            answ[asdf]++;
        }
        // krai na programata kogato N == boxes
        FOR(i,1,N) if (!opened[i])
        {
            
        }
        while(boxes < N)
        {
            int next = 1;
            //open_box(next);
            answ[asdf]++;
        }
        answ[asdf] = boxes;
    }
    cout << answ[0] << " " << answ[1] << endl;
    PAUSE;
    return 0;
}
*/
