/*
TASK: titanic
LANG: C++
*/
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <time.h>
#include <iomanip>
using namespace std;
#define DEBUG true
#define SHOW(v) if (DEBUG) cout << #v << " = " << v << endl;
#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define FORB(i,a,b) for(int i = a; i >= b; i--)
#define SHOWV(v) if (DEBUG) for(int tmp = 0; tmp <= v.size() - 1; tmp++) cout << #v << "[" << tmp << "] = " << v[tmp] << endl;
#define ALL(v) ((v).start()), ((v).end())
#define SZ size()
#define FORE(v,f) for_each(ALL(v), f);
#define PAUSE if (DEBUG) system("pause");
#define PII pair<int,int>
#define LL long long
#define LD long double 
#define PB push_back
#define VI vector<int>
#define WHERE if (DEBUG) cout << __FUNCTION__ << ":" << __LINE__ << endl;
#define MAXN 1024
#define MMIN -2147483647
inline int max(int a , int b) {return a > b ? a : b;}
struct sq
{
    int val;
    bool asked;
} sqs[MAXN][MAXN] = {0, false};
int N, M;
inline void showa(int x, int y)
{
    cout << "1 " << (x-1) << " " << (y-1) << endl;
    // cout << "1 " << x << " " << y << endl;
    //PAUSE;
    exit(0);
}
inline int ask(int x, int y)
{
    if (x < 1 || y < 1 || x > N || y > M) return MMIN;
    //if (x < 0 || y < 0 || x > N-1 || y > M-1) return MMIN;
    if (sqs[x][y].asked) return sqs[x][y].val;
    cout << "0 " << (x-1) << " " << (y-1) << endl;
    //cout << "0 " << x << " " << y << endl;
    int tmp;
    cin >> tmp;
    sqs[x][y].asked = true;
    sqs[x][y].val = tmp;
    return tmp;
}
inline void check(int x, int y)
{
    int e = ask(x, y);
    if (e > ask(x - 1, y) && 
        e > ask(x, y - 1) && 
        e > ask(x + 1, y) && 
        e > ask(x, y + 1))
            showa(x, y);
}
void solve(int x, int y)
{
    check(x, y);
    int a1 = ask(x + 1, y);
    int a2 = ask(x, y + 1);
    int a3 = ask(x - 1, y);
    int a4 = ask(x, y - 1);
    int mx = max(max(a1, a2), max(a3, a4));
    if (mx == a1) solve(x + 1, y);
    if (mx == a2) solve(x, y + 1);
    if (mx == a3) solve(x - 1, y);
    if (mx == a4) solve(x, y - 1);
}
int main()
{
    cin >> N >> M;
    int a1 = ask(1, 1);
    int a2 = ask(1, M);
    int a3 = ask(N, 1);
    int a4 = ask(N, M);
    /*
    int a1 = ask(0, 0);
    int a2 = ask(0, M-1);
    int a3 = ask(N-1, 0);
    int a4 = ask(N-1, M-1);
    */
    int mx = max(max(a1, a2), max(a3, a4));
    /*
    if (mx == a1) solve(0, 0);
    if (mx == a2) solve(0, M-1);
    if (mx == a3) solve(N-1, 0);
    if (mx == a4) solve(N-1, M-1);
    */
    if (mx == a1) solve(1, 1);
    if (mx == a2) solve(1, M);
    if (mx == a3) solve(N, 1);
    if (mx == a4) solve(N, M);
    return 0;
}
