/*
TASK:titanic
LANG:C++
*/

#include <cstdio>
#include <cstdlib>

#define MINUS -1<<30

long a[1024][1024];
char scand[1024][1024];
char used[1024][1024];
int n, m, k;

void read ()
{
  scanf ("%d%d", &n, &m);
}

long call (int x, int y)
{  
  if (x < 0 || y < 0 || x >= n || y >= m) return MINUS;
  if (scand[y][x] == 0)
  {
    scand[y][x] = 1;
    printf ("0 %d %d\n", x, y);
    scanf("%d", &a[y][x]);
    ++k;
  }
  return a[y][x];
}

int answer(int x, int y)
{
  printf ("1 %d %d\n", x, y);
}

long check4 (int x, int y)
{
  long c[8] = {call(x, y), call(x+1, y), call(x, y-1), call(x-1, y), call (x, y+1)};
  int maxi = 0;
  for (int i = 0; i < 5; ++i)
  {
    if (c[i] > c[maxi]) maxi = i;
  }    
  return maxi;
}

int main()
{
  read();
  int x = rand()%n, y = rand()%m, ch;
  while ((ch = check4 (x, y)) != 0)
  {    
    if (ch == 1) ++x;
    if (ch == 2) --y;
    if (ch == 3) --x;
    if (ch == 4) ++y;
    if (k == 3049) 
    {
      answer (x, y);
      break;
    }
  }
  answer (x, y);
}
