/*
TASK: boxes
LANG: C++
*/

#include <cstdio>
#include <algorithm>

const int MAXN = 100000 + 5;

int n, ans;
int prev[MAXN];
bool used[MAXN];

void init (void) {
    scanf("%d", &n);
    for (int i = 1; i <= n; ++i) {
        scanf("%d", prev+i);
        used[i] = false;
    }
    ans = 1;
}

void go (int x) {
    if (used[x]) return;
    used[x] = true;
    go(prev[x]);
    prev[x] = prev[prev[x]];
}

void solve (bool end) {
    int i;
    for (i = 1; i <= n; ++i) go(i);
    std::sort(prev+1,prev+n+1);
    //for (i = 1; i <= n; ++i) printf("%d\n", prev[i]);
    for (i = 2; i <= n; ++i) ans += (prev[i] != prev[i-1]);
    printf("%d%c", ans, end?'\n':' ');
}

int main () {
    init();
    solve(false);
    init();
    solve(true);

    return 0;
}
