/*
task:msweeper
lang:c++
*/
#include<iostream>
#include<cstdio>
#include<vector>
#include<stack>
#include<cmath>
using namespace std;
struct point{
       int x,y;
       point(){};
       point(int a,int b){x=a;y=b;}
       bool operator<(const point &b)const{
            if(x==b.x) return y<b.y;
            return x<b.x;
            }
       bool operator!=(const point &b)const{
            if(x!=b.x && y!=b.y) return true;
            return false;
            }
       };
stack<point> st;
void take(point &a,point &b){
     a=st.top();
     st.pop();
     b=st.top();
     st.push(a);
     }
double naslice(point a,point b,point c){
       double res=0.5*double((a.x-b.x)*(a.y+b.y)+(b.x-c.x)*(b.y+c.y)+(c.x-a.x)*(c.y+a.y));
       return res;
       }
double razst(point a,point b){
       double res=sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
       return res;
       }
int main(){
    double pi=pi=3.1415926535897932384626433832795;
    int n2,n=1,r;
    point a[10004],a1[10004],b[30004];
    scanf("%d %d",&n2,&r);
    for(int i=0;i<n2;i++) scanf("%d %d",&a1[i].x,&a1[i].y);
    sort(a1,a1+n2);
    a[0]=a1[0];
    for(int i=1;i<n2;i++){
    if(a1[i].x!=a1[i-1].x || a1[i].y!=a1[i-1].y){a[n]=a1[i];n++;}}
    if(n==1){
             double one_p=2.*pi*double(r);
             printf("%f\n",one_p);
             return 0;
             }
    if(n==2){
             double two_p=2*pi*double(r)+razst(a[0],a[1]);
             printf("%f\n",two_p);
             return 0;
             }
    //cout << a1[0].x << ' ' << a1[0].y << ' ' <<a1[n-1].x << ' ' << a1[n-1].y << endl;
    st.push(a[0]);
    st.push(a[1]);
    for(int i=2;i<n;i++){
       point p1,p2;
       take(p1,p2);
       while(st.size()>1 && naslice(a[i],p1,p2)<0){
                         st.pop();
                         if(st.size()>1) take(p1,p2);
                         }
       st.push(a[i]);
       }
    st.pop();
    int k=0;
    while(st.size()>0){
                       b[k]=st.top();
                       st.pop();
                       k++;
                       }
    st.push(a[n-1]);
    st.push(a[n-2]);
    for(int i=n-3;i>=0;i--){
            point p1,p2;
            take(p1,p2);
            while(st.size()>1 && naslice(a[i],p1,p2)<0){
                         st.pop();
                         if(st.size()>1) take(p1,p2);
                         }
            st.push(a[i]);
            }
    st.pop();
    while(st.size()>0){
                       b[k]=st.top();
                       st.pop();
                       k++;
                       }
    b[k]=b[0];
    b[k+1]=b[1];
    double len=0;
    for(int i=1;i<=k;i++){
            len+=razst(b[i],b[i+1]);
            double s1=razst(b[i-1],b[i]);
            double s2=razst(b[i],b[i+1]);
            double s3=razst(b[i-1],b[i+1]);
            double cosa=double(s1*s1+s2*s2-s3*s3)/(2.*s1*s2);
            double ang=pi-acos(cosa);
            double r2=fabs((ang/(2.*pi))*2.*pi*double(r));
            len+=r2;
            }
    printf("%f\n",len);
    return 0;
}
