/*
TASK: boxes
LANG: C++
*/
#include <iostream>
#include <queue>
#include <vector>
#define MAXN 100005
using namespace std;

int N;
vector< int > A[MAXN];
bool used[MAXN];

void BFS(int v)
{
    int i, sz;
    queue< int > q;
    used[v] = 1;
    q.push(v);
    
    while (!q.empty())
    {
       v = q.front();
       q.pop();
       sz = (int)A[v].size();
       for (i=0;i < sz;i++)
        if (!used[A[v][i]])
        {
           q.push(A[v][i]);
           used[A[v][i]] = 1;
        }
    }
}

int main()
{
    int ans[2];
    for (int k=0;k < 2;k++)
    {
        int i, j;
        scanf("%d", &N);
        
        if (k == 1)
         for (i=0;i < N;i++)
          A[i].clear();
        
        for (i=0;i < N;i++)
        {
            scanf("%d", &j);
            A[i].push_back(j-1);
            A[j-1].push_back(i);
        }
        
        ans[k] = 0;
        memset(used, 0, sizeof(used));
        for (i=0;i < N;i++)
         if (!used[i])
         {
            BFS(i);
            ans[k]++;
         }
    }
    
    cout << ans[0] << " " << ans[1] << endl;
    //cout << clock() << endl;
    return 0;
}
