/*
TASK: titanic
LANG: C++
*/
#include <iostream>
#define MAXN 1005
using namespace std;

int N, M;
int A[MAXN][MAXN];
bool b[MAXN][MAXN];
bool used[MAXN][MAXN];

void Ask(int x, int y)
{
     if (!b[x][y])
     {
         printf("0 %d %d\n", x, y);
         scanf("%d", &A[x][y]);
         b[x][y] = 1;
     }
}

int main()
{
    memset(b, 0, sizeof(b));
    memset(used, 0, sizeof(used));
    scanf("%d%d", &N, &M);
    
    int i(N/2), j(M/2), new_i, new_j;
    while (true)
    {
       new_i = i;
       new_j = j;
       used[i][j] = 1;
       Ask(i, j);
       
       if (i < N-1)
       {
          Ask(i+1, j);
          if (A[i+1][j] >= A[new_i][new_j] && !used[i+1][j]) new_i++;
       }
       if (j < M-1)
       {
          Ask(i, j+1);
          if (A[i][j+1] >= A[new_i][new_j] && !used[i][j+1]) new_j++;
       }
       if (i > 0)
       {
          Ask(i-1, j);
          if (A[i-1][j] >= A[new_i][new_j] && !used[i-1][j]) new_i--;
       }
       if (j > 0)
       {
          Ask(i, j-1);
          if (A[i][j-1] >= A[new_i][new_j] && !used[i][j-1]) new_j--;
       }
       
       if (new_i == i && new_j == j) // we found a solution
       {
          printf("1 %d %d\n", i, j);
          break;
       }
       
       i = new_i;
       j = new_j;
    }
    
    return 0;
}
