/*
LANG:C++
TASK:boxes
*/
#include <iostream>
#include <vector>
using namespace std;


vector <int> graph[100000];
bool visited[100000] = {0};
int prev[100000];
int n;
int cnt = 0;

void dfs(int i){
     visited[i] = 1;
     for(int j = 0; j < graph[i].size(); j++){
             if( !visited[graph[i][j]] ){
                 dfs( graph[i][j]);    
             }        
     }
     if(!visited[prev[i]])
           dfs(prev[i]);     
}

int main(){
    for(int f = 0; f < 2; f++){
    cin >> n;
    for(int i = 0; i < n; i++)
            graph[i].resize(0);
    cnt = 0;
    for(int i = 0; i < n; i++){
            visited[i] = 0;
            int j;
            cin >> j;
            graph[j-1].push_back(i);
            prev[i] = j-1;      
    }
    
    for(int i = 0; i < n; i++)
            if(!visited[i]){
                            dfs(i);
                            cnt ++;               
            }
    if(f) 
          cout << " ";
    cout << cnt ;
    }
    cout << endl;
    return 0;
}
