/*
TASK:titanic
LANG:C++
*/
#include <iostream>
#include <ctime>
#include <cstdlib>
#include <cstdio>

using namespace std;

long long h[1010][1010];

const long long MX = 2147483647;
const long long UC = MX + 1;
const long long KR = -MX - 2;
int m ,n;

pair <int,int> randxy(){
     pair <int,int> ret;
     int times = 0;
     do{
        ret.first = rand()%(m) + 1;
        ret.second = rand()%(n) + 1;
        times++;
     }while(h[ret.first][ret.second] != UC && times < 10);
     
     if(times == 10){
     for( ret.first = 1; ret.first <= m; ret.first ++)
             for( ret.second = 1; ret.second <= n; ret.second ++)
                     if(h[ret.first][ret.second] != UC)
                                                 break;
     }
     return ret;     
}

long long read(int x, int y){
   if(h[x][y] == UC){
              long long r;
              cout << "0 " << x - 1 << " " << y - 1 << endl;
              cin >> r;
              h[x][y] = r;
   }

   return h[x][y];
}

void check(int x, int y){
          long long ch = read(x,y);
          long long cb;
          pair <int,int> newxy;
          
          cb = read(x-1,y);
          if( ch < cb){
              check(x-1,y);
          }
          if (ch == cb){
             newxy = randxy();
             check(newxy.first, newxy.second);
          }
          
          cb = read(x+1,y);
          if( ch < cb){
              check(x+1,y);
          }
          if (ch == cb){
             newxy = randxy();
             check(newxy.first, newxy.second);
          }
          
          cb = read(x,y-1);
          if( ch < cb){
              check(x,y-1);
              }
          if (ch == cb){
             newxy = randxy();
             check(newxy.first, newxy.second);
          }
          
          cb = read(x,y+1);
          if( ch < cb){
              check(x,y+1);
          }
          if (ch == cb){
             newxy = randxy();
             check(newxy.first, newxy.second);
          }
          cout << "1 " << x - 1 << " " << y - 1 << endl; 
          exit(0);    
}

void dg(){
         for(int i = 0; i < m + 2; i++){
            for(int j = 0; j < n + 2; j++)
                    cout << h[i][j] << " ";
            cout << endl;
    }     
}

int main(){
    srand(clock()*clock());
    cin >> m >> n;
    for(int i = 0; i < m + 2; i++)
            for(int j = 0; j < n + 2; j++)
                    h[i][j] = UC;
    for(int i = 0; i < m + 2; i++){
            h[i][0] = KR;
            h[i][n+1] = KR;
    }
    for(int i = 0; i < n + 2; i++){
            h[0][i] = KR;
            h[m+1][i] = KR;
    }
    if(m * n <= 3500){
         for(int i = 1; i < m + 1; i++){
                 for(int j = 1; j < n + 1; j++){
                         long long ch = read(i,j);
                         if( ch > read(i-1,j) && ch > read(i+1,j) && ch > read(i,j+1) && ch > read(i,j-1))
                         {
                             cout << "1 " << i - 1 << " " << j -1 << endl;
                             //dg();
                             return 0;
                         }
                 }
         }
    }
    
    srand(clock()*clock());
    
    pair <int,int> xy = randxy();
    check(xy.first, xy.second);
    return 0;
    
}
