/*
TASK:msweeper
LANG:C++
*/
#include <iostream>
#include <stack>
#include <math.h>

using namespace std;

struct point{
       int x,y;
};

int n,r,i,j,ch[11000],k;
point p[11000];
point h;
double P=0;

int CP(point p0,point p1,point p2){
       return (p1.x-p0.x)*(p2.y-p0.y)-(p1.y-p0.y)*(p2.x-p0.x);
}

int sqdist(point p1,point p2){
    return (p2.x-p1.x)*(p2.x-p1.x)+(p2.y-p1.y)*(p2.y-p1.y);
}

bool cmpA(point A,point B){
     k=CP(p[0],A,B);
     if(k==0){
         if(A.x==B.x) return A.y>B.y;
         return A.x<B.x;
     }
     return k>0;
}

int main(){
    scanf("%d %d",&n,&r);
    scanf("%d %d",&p[0].x,&p[0].y);
    j=0;
    for(i=1;i<n;i++){
        scanf("%d %d",&p[i].x,&p[i].y);
        if((p[j].x==p[i].x&&p[j].y>p[i].y)||(p[j].x>p[i].x)) j=i;
    }
    h=p[0];p[0]=p[j];p[j]=h;
    sort(p+1,p+n,cmpA);
    ch[0]=2;ch[1]=0;ch[2]=1;
    for(i=2;i<n;i++){
        while(CP(p[ch[ch[0]-1]],p[ch[ch[0]]],p[i])<0) ch[0]--;
        ch[0]++;
        ch[ch[0]]=i;
    }
    for(i=2;i<=ch[0];i++){
        P+=sqrt(sqdist(p[ch[i-1]],p[ch[i]]));
    }
    P+=sqrt(sqdist(p[ch[ch[0]]],p[ch[1]]));
    P+=2*M_PI*r;
    printf("%.3f\n",P);
    return 0;
}
