/*
TASK: msweeper
LANG: C++
*/

#include <iostream>
#include <stdio.h>
#include <math.h>
using namespace std;

typedef long double LD;

LD abs(LD r) {return r>0?r:-r;}

struct point
{
       int x, y;
       point() {}
       point(int _x, int _y) {x=_x; y=_y;}
};

point P[16384],Q[16384];
int N, R;
point X;

LD sum;

bool cmp(point a, point b)
{
     if(a.x==X.x) {
                  if(b.x==X.x) {return a.y<b.y;}
                  else {return 1;}
     }
     return (1.0*(a.y-X.y)/(a.x-X.x))>(1.0*(b.y-X.y)/(b.x-X.x));
}

LD dist(point a, point b)
{
      return sqrt(((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y))*1.0);
}

LD cp(point a, point b, point c)
{
       int dx1 = b.x-a.x,dx2=c.x-a.x,dy1=b.y-a.y,dy2=c.y-a.y;
       return 1.0*(dx1*dy2-dx2*dy1);
}

LD sp(point a, point b, point c)
{
       int dx1 = b.x-a.x,dx2=c.x-a.x,dy1=b.y-a.y,dy2=c.y-a.y;
       return 1.0*(dx1*dx2+dy1*dy2);
}

int main()
{
    scanf("%d %d", &N, &R);
    //cin>>N>>R; //rewrite w stdio
    for(int i=0; i<N; i++)
    {
            //cin>>P[i].x>>P[i].y;
            scanf("%d %d", &P[i].x, &P[i].y);
    }
    int mi=0, mx=P[0].x;
    for(int i=1; i<N; i++)
    {
            if(P[i].x<mx) {mx=P[i].x; mi=i;}
            if(P[i].x==mx&&P[i].y<P[mi].y) {mi = i;}
    }
    X=P[mi];
    swap(P[0],P[mi]);
    //cout<<"X: "<<X.x<<" "<<X.y<<endl;
    sort(P+1, P+N, cmp);
    Q[0]=P[0]; Q[1] = P[1];
    int cnt=2;
    for(int i=2; i<N; i++)
    {
            Q[cnt]=P[i];
            while(cp(Q[cnt-2],Q[cnt-1],Q[cnt])>=0&&cnt>2) {Q[--cnt]=P[i];}
            cnt++;
    }
    for(int i=0; i<cnt; i++)
    {
            sum+=dist(Q[i], Q[(i+1)%cnt]);;
    }
    point Pr,Nx;
    for(int i=0; i<cnt; i++)
    {
            Pr = Q[(cnt+i-1)%cnt];
            Nx = Q[(i+1)%cnt];
            LD S = abs(cp(Q[i],Pr,Nx));
            if(S==0) {continue;}
            LD san = S/dist(Q[i],Pr)/dist(Q[i],Nx);
            LD an = asin(san);
            if(sp(Q[i],Pr,Nx)<0)
            {
               sum+=an*R;
            }
            else {sum+=(M_PI-an)*R;}
            //cout<<an<<endl;
    }
    cout<<sum<<endl;
    return 0;
}
