/*
TASK: diamonds
LANG: C++
*/
#include <stdio.h>
using namespace std;

long long I[101][101][101];
int L, M, N;

void add(int i1, int j1, int k1, int val)
{
     for (int i = i1; i <= N; i += i&(-i))
      for (int j = j1; j <= M; j += j&(-j))
      {
          //I[i][j][k1] += val;
          //if (k1 + (k1&(-k1)) <= L) I[i][j][k1+(k1&(-k1))] += I[i][j][k1];
          for (int k = k1; k <= L; k += k&(-k))
           I[i][j][k] += val;
      }
}

long long f(int i1, int j1, int k1)
{
    long long res = 0;
    for (int i = i1; i > 0; i -= i&(-i))
     for (int j = j1; j > 0; j -= j&(-j))
      for (int k = k1; k > 0; k -= k&(-k))
       res += I[i][j][k];
    return res;
}

int main()
{
    scanf("%d%d%d", &L, &M, &N);
    
    for (int i = 1; i <= N; i++)
     for (int j = 1; j <= M; j++)
      for (int k = 1; k <= L; k++)
      {
          int a;
          scanf("%d", &a);
          add(i, j, k, a);
      }
    
    //printf("%d\n", f(2, 2, 2));
    int i1, j1, k1, i2, j2, k2;
    while (scanf("%d%d%d%d%d%d", &k1, &j1, &i1, &k2, &j2, &i2) != -1)
    {
         // i2++, j2++, k2++;
          printf("%lld\n", f(i2, j2, k2) - f(i1, j2, k2) - f(i2, j1, k2) - f(i2, j2, k1)
                                         + f(i2, j1, k1) + f(i1, j2, k1) + f(i1, j1, k2)
                          -f(i1, j1, k1));
    }   
    return 0;
}
