/*
TASK: diamonds
LANG: C++
*/

#include <cstdio>

const int MAX_N = 100 + 5;

int N, M, L;
int v[MAX_N][MAX_N][MAX_N];
int to[MAX_N][MAX_N][MAX_N];

inline int query(int x, int y, int z)
{
	if(x < 0 || y < 0 || z < 0)	return 0;
	return to[z][y][x];
}

inline int query(int x1, int y1, int z1, int x2, int y2, int z2)
{
//	printf("%d\n", + query(x2, y2, z2));
//	printf("%d\n", );
	return  
			int(
			(long long)(
			+ (long long)query(x2, y2, z2)
			- (long long)query(x1 - 1, y2, z2)
			- (long long)query(x2, y1 - 1, z2)
			- (long long)query(x2, y2, z1 - 1)
			+ (long long)query(x2, y1 - 1, z1 - 1)
			+ (long long)query(x1 - 1, y2, z1 - 1)
			+ (long long)query(x1 - 1, y1 - 1, z2)
			- (long long)query(x1 - 1, y1 - 1, z1 - 1)
			)
			)
			;
}

int x1, x2, y1, y2, z1, z2;
int main()
{
	scanf("%d %d %d", &L, &M, &N);
	for(int i = 0; i < N; i ++)
		for(int j = 0; j < M; j ++)
			for(int k = 0; k < L; k ++)
				scanf("%d", &v[i][j][k]);
	for(int i = 0; i < N; i ++)
		for(int j = 0; j < M; j ++)
		{
			to[i][j][0] = v[i][j][0];
			for(int k = 1; k < L; k ++)
				to[i][j][k] = to[i][j][k - 1] + v[i][j][k];
		}
	for(int i = 0; i < N; i ++)
		for(int j = 1; j < M; j ++)
			for(int k = 0; k < L; k ++)
				to[i][j][k] += to[i][j - 1][k];
	for(int i = 1; i < N; i ++)
		for(int j = 0; j < M; j ++)
			for(int k = 0; k < L; k ++)
				to[i][j][k] += to[i - 1][j][k];
	while( scanf("%d %d %d %d %d %d", &x1, &y1, &z1, &x2, &y2, &z2) == 6 )
	{
		int res = 0;
		x2 --; y2 --; z2 --;
		res = query(x1, y1, z1, x2, y2, z2);
		printf("%d\n", res);
	}
	return 0;
}
