/*
TASK: frogs
LANG: C++
*/
#include <cstdio>
#include <stack>
#include <queue>
using namespace std;

const int maxn=1000000;
int h[maxn], p[maxn], *p1000;
stack <int> *st;

void getp1000(int i)
{
	queue<int> q;
	int j;
	for(;i!=-1;i=p[i])
	{
		q.push(i);
		if(q.size()>1000)
		{
			j=q.front();
			q.pop();
			p1000[j]=i;
		}
	}
	while(!q.empty()) { j=q.front(); q.pop(); p1000[j]=-1; }
}

int geth(int i, int cnt)
{
	while(cnt>0)
	{
		if(cnt>1000) { i=p1000[i]; cnt-=1000; }
		else { i=p[i]; cnt--; }
		if(i==-1) break;
	}
	return i==-1?i:h[i];
}

int main()
{
	int n;
	scanf("%d", &n);
	
	int i;
	for(i=0; i<n; i++) scanf("%d", h+i);
	
	st=new stack<int>;
	st->push(n-1);
	p[n-1]=-1;
	for(i=n-2; i>=0; i--)
	{
		while(!st->empty() && h[i]>=h[st->top()]) st->pop();
		p[i]=st->empty()?-1:st->top();
		st->push(i);
	}

	delete st;
	
	p1000=new int[maxn];
	for(i=0; i<n; i++) p1000[i]=-2;
	
	for(i=0; i<n; i++) if(p1000[i]==-2) getp1000(i);
	
	int cnt;
	for(i=0; i<n; i++)
	{
		scanf("%d", &cnt);
		if(i!=0) printf(" ");
		printf("%d", geth(i, cnt));
	}
	printf("\n");
	
	return 0;
}
