/*
TASK: frogs
LANG: C++
*/
#include <iostream>
#include <queue>
#define MAXN 1000005
using namespace std;

int jumps[MAXN];
int cpos[MAXN];
int h[MAXN];
int N;

struct pi
{
    int ind;
    bool operator<(const pi &x) const
    { return h[cpos[ind]] >= h[cpos[x.ind]]; }
};
priority_queue< pi > pq;

int main()
{
    int i;
    pi k;
    scanf("%d", &N);
    for (i=k.ind=0;i < N;i++,k.ind++)
    {
        cpos[i] = i;
        scanf("%d", &h[i]);
        pq.push(k);
    }
    cpos[N] = N;
    h[N] = -1;
    for (i=0;i < N;i++)
     scanf("%d", &jumps[i]);
    
    while(!pq.empty())
    {
        k = pq.top();
        pq.pop();
        //cout << k.ind << endl;
        cpos[k.ind] = cpos[cpos[k.ind] + 1];
        if (cpos[k.ind] == N)
        {
           jumps[k.ind] = -1;
           continue;
        }
        
        jumps[k.ind]--;
        if (jumps[k.ind] == 0) jumps[k.ind] = h[cpos[k.ind]]; // use jumps to store max h
        else pq.push(k); 
    }
    
    cout << jumps[0];
    for (i=1;i < N;i++)
     cout << " " << jumps[i];
    cout << endl;
    
    //system("pause");
    return 0;
}
