/*
TASK:diamonds
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <bitset>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <functional>
#include <utility>
#include <numeric>

using namespace std;

#define F(i,n) for (int i=0;i<n;i++)
#define Repi(n) F(i,n)
#define Repj(n) F(j,n)
#define Repk(n) F(k,n)
#define LL long long
#define PI pair<int,int>
#define PD pair<double,double>
#define MP make_pair
#define x first
#define y second
#define PB push_back
#define SZ size()
#define VI vector<int>
#define IT iterator
#define ALL(v) (v).begin(),(v).end()
#define sqr(a) ((a)*(a))
#define ABS(a) (((a)>0)?(a):(-(a)))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)>(b))?(a):(b))
#define sign(a) (((a)>0)-((a)<0))

#define Time (double)clock()/CLOCKS_PER_SEC
#define pause system("pause")

int N,M,L;

int sum[101][128][128];

int real[101][101][101];

#define query1(x1,y1,z1,x2,y2,z2) (sum[x2][y2][z2]\
              -sum[x1][y2][z2]-sum[x2][y1][z2]-sum[x2][y2][z1]\
              +sum[x1][y1][z2]+sum[x2][y1][z1]+sum[x1][y2][z1]\
              -sum[x1][y1][z1])

inline int query(int x1,int y1,int z1,int x2,int y2,int z2)
{
       return sum[x2][y2][z2]
              -sum[x1][y2][z2]-sum[x2][y1][z2]-sum[x2][y2][z1]
              +sum[x1][y1][z2]+sum[x2][y1][z1]+sum[x1][y2][z1]
              -sum[x1][y1][z1];
}

inline int q2(int x1,int y1,int z1,int x2,int y2,int z2)
{
    int res=0;
    for (int i=x1+1;i<=x2;i++)
     for (int j=y1+1;j<=y2;j++)
      for (int k=z1+1;k<=z2;k++)
       res+=real[i][j][k];
    return res;
}

void brutetest()
{
    for (int i=0;i<N;i++)
     for (int j=0;j<M;j++)
      for (int k=0;k<L;k++)
    for (int i2=i+1;i2<=N;i2++)
     for (int j2=j+1;j2<=M;j2++)
      for (int k2=k+1;k2<=L;k2++)
       if (q2(i,j,k,i2,j2,k2)+1!=query(i,j,k,i2,j2,k2))
        cout<<" difference at "<<i<<" "<<j<<" "<<k<<" "<<i2<<" "<<j2<<" "<<k2<<" : "<<q2(i,j,k,i2,j2,k2)<<" "<<query(i,j,k,i2,j2,k2)<<"\n";
}

int main()
{
    int a;
    scanf("%d%d%d",&L,&M,&N);
    for (int i=1;i<=N;i++)
     for (int j=1;j<=M;j++)
      for (int k=1;k<=L;k++)
       {
         scanf("%d",&a);
         //real[i][j][k]=a;
        // cout<<" read "<<i<<" "<<j<<" "<<k<<"\n";
         sum[i][j][k]=a+sum[i-1][j][k]+sum[i][j-1][k]+sum[i][j][k-1]
                      -sum[i-1][j-1][k]-sum[i][j-1][k-1]-sum[i-1][j][k-1]
                      +sum[i-1][j-1][k-1];
       }
    
/*
    for (int i=1;i<=N;i++)
     for (int j=1;j<=M;j++)
      for (int k=1;k<=L;k++)
       {
               cout<<" "<<i<<" "<<j<<" "<<k<<" = "<<real[i][j][k]<<" ?= "<<query(i-1,j-1,k-1,i,j,k)<<"\n";
       }
*/  

    int x1,y1,z1,x2,y2,z2;
    while (scanf("%d%d%d%d%d%d",&z1,&y1,&x1,&z2,&y2,&x2)==6)
     {
           printf("%d\n",query(x1,y1,z1,x2,y2,z2));
           //cout<<" "<<q2(x1,y1,z1,x2,y2,z2)<<"\n";
     }
    fprintf(stderr,"%.5lf\n",Time);
     
   // brutetest();
    
    return 0;
}

