/*
TASK:frogs
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <bitset>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <functional>
#include <utility>
#include <numeric>

using namespace std;

#define F(i,n) for (int i=0;i<n;i++)
#define Repi(n) F(i,n)
#define Repj(n) F(j,n)
#define Repk(n) F(k,n)
#define LL long long
#define PI pair<int,int>
#define PD pair<double,double>
#define MP make_pair
#define x first
#define y second
#define PB push_back
#define SZ size()
#define VI vector<int>
#define IT iterator
#define ALL(v) (v).begin(),(v).end()
#define sqr(a) ((a)*(a))
#define ABS(a) (((a)>0)?(a):(-(a)))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)>(b))?(a):(b))
#define sign(a) (((a)>0)-((a)<0))

#define Time (double)clock()/CLOCKS_PER_SEC
#define pause system("pause")

const int MAXN=1000001;
int N;
int H[MAXN],s[MAXN],sc,J[MAXN];

void solve()
{
     sc=0; int tmp;
     for (int i=N-1;i>=0;i--)
      {
              tmp=H[i];
              while (sc && s[sc-1]<=tmp) sc--;
              if (sc>=J[i])
               H[i]=s[sc-J[i]];
              else H[i]=-1;
              s[sc++]=tmp;
      }
}


int main()
{
    scanf("%d",&N);
    Repi(N)
     scanf("%d",H+i);
    Repi(N)
     scanf("%d",J+i);
    sc=0;
    
    solve();
    
    Repi(N-1)
     printf("%d ",H[i]);
    printf("%d\n",H[N-1]);
    
    
    return 0;
}

