/*
TASK:diamonds
LANG:C++
*/

#include <iostream>
#include <cstdio>

using namespace std;

int L, M, N, x1, y1, z1, x2, y2, z2;
int A[128][128][128], dp[128][128][128];

int main() {
	scanf("%d%d%d", &L, &M, &N);
	for (int n=0; n<N; ++n)
		for (int m=0; m<M; ++m)
			for (int l=0; l<L; ++l)
				scanf("%d", &A[n][m][l]);
	dp[0][0][0]=A[0][0][0];
	for (int n=1; n<N; ++n)
		dp[n][0][0]=A[n][0][0]+dp[n-1][0][0];
	for (int m=1; m<M; ++m)
		dp[0][m][0]=A[0][m][0]+dp[0][m-1][0];
	for (int l=0; l<L; ++l)
		dp[0][0][l]=A[0][0][l]+dp[0][0][l-1];
	for (int n=1; n<N; ++n)
		for (int m=1; m<M; ++m)
			dp[n][m][0]=A[n][m][0]+dp[n-1][m][0]+dp[n][m-1][0]-dp[n-1][m-1][0];
	for (int m=1; m<M; ++m)
		for (int l=1; l<L; ++l)
			dp[0][m][l]=A[0][m][l]+dp[0][m-1][l]+dp[0][m][l-1]-dp[0][m-1][l-1];
	for (int n=1; n<N; ++n)
		for (int l=1; l<L; ++l)
			dp[n][0][l]=A[n][0][l]+dp[n-1][0][l]+dp[n][0][l-1]-dp[n-1][0][l-1]; 
	for (int n=1; n<N; ++n)
		for (int m=1; m<M; ++m)
			for (int l=1; l<L; ++l) {
				dp[n][m][l]=A[n][m][l]+dp[n][m-1][l]+dp[n][m][l-1]-dp[n][m-1][l-1]+dp[n-1][m][l]-dp[n-1][m-1][l]-dp[n-1][m][l-1]+dp[n-1][m-1][l-1];
			}
	while (cin >> x1) {
		  scanf("%d%d%d%d%d", &y1, &z1, &x2, &y2, &z2);
		  --x1;
		  --y1;
		  --z1;
		  --x2;
		  --y2;
		  --z2;
		  int a, b, c, d, e, f, g, h;
		  if (x2==-1 || y2==-1 || z2==-1) a=0;
		  else a=dp[z2][y2][x2];
		  if (x2==-1 || y1==-1 || z2==-1) b=0;
		  else b=dp[z2][y1][x2];
		  if (x2==-1 || y2==-1 || z1==-1) c=0;
		  else c=dp[z1][y2][x2];
		  if (x2==-1 || y1==-1 || z1==-1) d=0;
		  else d=dp[z1][y1][x2];
		  if (x1==-1 || y2==-1 || z2==-1) e=0;
		  else e=dp[z2][y2][x1];
		  if (x1==-1 || y1==-1 || z2==-1) f=0;
		  else f=dp[z2][y1][x1];
		  if (x1==-1 || y2==-1 || z1==-1) g=0;
		  else g=dp[z1][y2][x1];
		  if (x1==-1 || y1==-1 || z1==-1) h=0;
		  else h=dp[z1][y1][x1];
		  printf("%d\n", a-b-c+d-e+f+g-h);
 	}
return 0;
}
