/*
TASK:frogs
LANG:C++
*/
#include <cstdio>
#include <vector>

using namespace std;

long n, ngroups;
long h[1000001];
long group[1000001];
long pos[1000001];

vector < vector < long > > groups;

int main ()
{
  scanf ("%d %d", &n, &h[0]);
  
  vector <long> v;
  v.push_back (0);
  groups.push_back(v);
  
  group[0] = 0;
  pos[0] = 0;
  
  for (int i = 1; i < n; ++i)
  {
    scanf ("%d", &h[i]);
    if (h[i] < h[i-1])
    {
      group[i] = groups.size();
      pos[i] = 0;
      
      vector <long> v1;
      v1.push_back (i);      
      groups.push_back(v1);
    } else {
      int j = 0;
      for (; j < groups.size(); ++j)
      {
	if (h[i] > h[groups[j][groups[j].size()-1]]) break;
      }	
      group[i] = j;
      pos[i] = groups[j].size();
      for (; j < groups.size(); ++j)
      {
	groups[j].push_back (i);
      }
    }
  }
  
  int J;
  for (int i = 0; i < n; ++i)
  {
    scanf ("%d", &J);
    if (J + pos[i] >= groups[group[i]].size())
      printf ("-1");
    else
      printf ("%d", h[groups[group[i]][J + pos[i]]]);
    if (i < n-1) printf (" ");
  }
  printf ("\n");
  
  return 0;
}