/*
TASK:frogs
LANG:C++
*/
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
using namespace std;
struct frog{
  int num_bala,height,jumps;
  bool operator<(const frog& w) const{
    if(height<w.height) return true;
    if(height==w.height)
      if(num_bala<w.num_bala) return true;
    return false;
                                     }
};
vector<frog> vhod;
int n;
int tree[1000050];
int ans[1000050];
int heights[1000010];
void push(int pos){
  for(;pos<1000005;pos+=((pos)&(-pos))) tree[pos]++;
}
int get(int up_to){
  if(up_to<=0) return 0;
  int ans=0;
  while(up_to>0){
    ans+=tree[up_to];
    up_to-=((up_to)&(-up_to));
                }
  return ans;
}
int find_interval(int f,int t){
  return (get(t)-get(f-1));
}
int find_what;
int begin_from;
int bin_find(int f,int t){
  if(f==t) return f;
  if(f+1==t){
    if(find_interval(begin_from,f)==find_what) return f;
    return t;
            }
  int mid=(f+t)/2;
  if(find_interval(begin_from,mid)>=find_what) return bin_find(begin_from,mid);
  else return bin_find(mid,t);
}
int main(){
  //system("pause");
  scanf("%ld",&n);
  int i,j,k,l;
  frog tmp;
  for(i=0;i<n;i++){
    tmp.num_bala=i+1;
    scanf("%ld",&tmp.height);
    heights[i]=tmp.height;
    vhod.push_back(tmp);
                  }
  for(i=0;i<n;i++){
    scanf("%ld",&vhod[i].jumps);
                  }
  sort(vhod.begin(),vhod.end());
  //for(i=0;i<n;i++) cout<<vhod[i].num_bala<<' '<<vhod[i].height<<' '<<vhod[i].jumps<<endl;
  push(1000004);
  if(vhod[n-1].jumps==0) ans[vhod[n-1].num_bala]=vhod[n-1].height;
  else ans[vhod[n-1].num_bala]=-1;
  push(vhod[n-1].num_bala);
  for(i=n-2;i>=0;i--){
    //cout<<vhod[i].height;
    //system("pause");
    if(vhod[i].jumps==0) ans[vhod[i].num_bala]=vhod[i].height;
    else{
      find_what=vhod[i].jumps;
      begin_from=vhod[i].num_bala;
      j=bin_find(vhod[i].num_bala,1000004);
      //cout<<'!'<<j;system("pause");
      if(j>1000000) ans[vhod[i].num_bala]=-1;
      else ans[vhod[i].num_bala]=heights[j-1];
      //cout<<"!"<<ans[vhod[i].num_bala];system("pause");
        }
    push(vhod[i].num_bala);
                     }
  for(i=1;i<(n);i++) printf("%ld ",ans[i]);
  printf("%ld\n",ans[n]);
  //system("pause");
  return 0;
}
