/*
LANG: C++
TASK: special
*/

#include <cstdio>
#include <string>
#include <cstdlib>

using namespace std;

string t1[64];
int gen_t1(int len) {
    if(len < 2) return 0;
    int cnt = 0;
    for(int i = 0; i < len; ++i) {
        t1[cnt++] = string(i, '9')+"7"+string(len-i-1, '0');
    }
    return cnt;
}

string t2[64];
int gen_t2(int len) {
    if(len < 4) return 0;
    string tpl = "2"+string(len-1, '0');
    int pos1 = (len-1)/2;
    int cnt = 0;
    while(pos1 >= 1) {
        t2[cnt] = tpl;
        t2[cnt][pos1] = '1';
        t2[cnt][pos1*2] = '2';
        ++cnt;
        --pos1;
    }
    return cnt;
}

string t3[1];
int gen_t3(int len) {
    if(len < 4) return 0;
    t3[0] = "3148"+string(len-4, '0');
    return 1;
}

string t4[1];
int gen_t4(int len) {
    if(len < 7) return 0;
    t4[0] = "3074003"+string(len-7, '0');
    return 1;
}

void bail(string s) {
    printf("%s\n", s.c_str());
    exit(0);
}

int main() {
    int n;
    scanf("%d", &n);
    int cn = 0, ci = 1;
    while(true) {
        cn = gen_t2(ci);
        if(cn >= n)
            bail(t2[n-1]);
        n -= cn;

        cn = gen_t4(ci);
        if(cn >= n)
            bail(t4[n-1]);
        n -= cn;

        cn = gen_t3(ci);
        if(cn >= n)
            bail(t3[n-1]);
        n -= cn;

        cn = gen_t1(ci);
        if(cn >= n)
            bail(t1[n-1]);
        n -= cn;

        ++ci;
    }
    return 0;
}
