/*
TASK: diamonds
LANG: C++
*/
#include<cstdio>
using namespace std;
#define lowb(x) (x)&(-x)
int itree[128][128][128];
int n,m,l;
void add(int x,int y,int z,int st)
{
 int i,j,k;
 for(i=x;i<=n;i+=lowb(i))
  for(j=y;j<=m;j+=lowb(j))
   for(k=z;k<=l;k+=lowb(k))
    itree[i][j][k]+=st;
}
int ask(int x,int y,int z)
{
 int i,j,k;
 int res=0;
 for(i=x;i>0;i-=lowb(i))
  for(j=y;j>0;j-=lowb(j))
   for(k=z;k>0;k-=lowb(k))
     res+=itree[i][j][k];
 return res;
}
int main()
{
 scanf("%d%d%d",&l,&m,&n);
 int i,j,k;
 for(i=1;i<=n;i++)
  for(j=1;j<=m;j++)
   for(k=1;k<=l;k++)
    {
     int c;
     scanf("%d",&c);
     add(i,j,k,c);
     
    }
 int x1,y1,z1;
 int x2,y2,z2;
 //printf("asdasd\n");
    
 
   while( scanf("%d%d%d%d%d%d",&z1,&y1,&x1,&z2,&y2,&x2)!=EOF )
 {  
    int up=ask(x2,y2,z2)-ask(x2,y1,z2);
    int s1=ask(x1,y2,z1)-ask(x1,y1,z1);
    int s2=ask(x2,y2,z1)-ask(x2,y1,z1)-s1;
    int s3=ask(x1,y2,z2)-ask(x1,y1,z2)-s1;
    printf("%d\n",up-s2-s3-s1);
  }
}