/*
TASK: diamonds
LANG: C++
*/
#include <cstdio>

const int MAXN = 1 << 7;

int n , m , l;
int a[MAXN][MAXN][MAXN];

void read() {
	int i , j , k;
	
	scanf ( "%d%d%d" , &l , &m , &n );
	
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++)
			for (k = 1; k <= l; k++) {
				scanf ( "%d" , &a[i][j][k] );
				
				a[i][j][k] = a[i][j][k] + a[i - 1][j][k] + a[i][j - 1][k] + a[i][j][k - 1];
				a[i][j][k] -= a[i - 1][j - 1][k] + a[i - 1][j][k - 1] + a[i][j - 1][k - 1];
				a[i][j][k] += a[i - 1][j - 1][k - 1];
			}
}

void solve() {
	int x1 , y1 , z1 , x2 , y2 , z2;
	int ans;
	
	while ( scanf ( "%d%d%d%d%d%d" , &z1 , &y1 , &x1 , &z2 , &y2 , &x2 ) != -1 ) {
		ans = a[x2][y2][z2];
		ans -= a[x1][y2][z2] + a[x2][y1][z2] + a[x2][y2][z1];
		ans += a[x1][y1][z2] + a[x1][y2][z1] + a[x2][y1][z1];
		ans -= a[x1][y1][z1];
		
		printf ( "%d\n" , ans );
	}
}

int main() {
	read();
	solve();
	
	return 0;
}
