/*
TASK: frogs
LANG: C++
*/
#include <stdio.h>
#include <algorithm>
#include <vector>
#define MAXN (1 << 19)
#define INF (1 << 30)
using namespace std;

struct el 
{
 int h , j ;
 el () {}       
 el ( int _h , int _j) : h (_h), j (_j) {}
};

int n ;
el a[ MAXN ] ;
int next[MAXN] , sol[MAXN];

int main ()
{
 scanf ("%d", &n);   
 
 for (int i=1 ; i <= n; ++i)
  scanf ("%d", & a[i].h );
 
 for (int i=1 ; i <= n; ++i)
  scanf ("%d", & a[i].j );
 
 for (int i=n; i >= 1; --i)
  {
   int j = i+1 ;
   while ( j <= n && a[j].h < a[i].h ) ++j;
   
   if ( j > n ) next[i] = -1;
    else next [i] = j ;
   
   sol[i] = i;
  
   while ( a[i].j )
    {
     sol[i] = next[sol[i]];
     a[i].j --;
     if ( sol[i] == -1 ) break;
    }
  }
 
 for (int i=1; i <= n; ++i)
  {
   printf ("%d",  sol[i] == -1 ? sol[i] : a [ sol[i] ].h);
   if ( i != n ) printf (" ");
   else printf ("\n");
  }
 return 0;    
}
