/*
TASK: frogs
LANG: C++
*/

#include <algorithm>
#include <list>
#include <set>
using namespace std;

#define DEBUG					PRINT SOME SHIT!!!
#undef DEBUG


int N, P;
int * height, * jumps, * ans, * path;
bool * parent;
list<int> * child;



typedef struct cmp
{
	bool operator () (int a, int b)
	{
		if(height[a] != height[b])
			return (height[a] < height[b]);
		
		return (a < b);
	}
};

set<int, cmp> S;


void DFS(int n)
{
	path[P ++] = n;
	
	if(P <= jumps[n]) ans[n] = - 1;
	else ans[n] = height[path[P - jumps[n] - 1]];
	
	for(list<int>::iterator it = child[n].begin(); it != child[n].end(); it ++)
	{
		DFS(* it);
	}
	
	P --;
}

int main()
{
	scanf("%d", & N);
	
	height = new int[N];
	parent = new bool[N];
	child = new list<int>[N];
	
	for(int i = 0; i < N; i ++)
		scanf("%d", & height[i]);
	
	
	for(int i = 0; i < N; i ++)
		parent[i] = false;
	
	for(int i = 0; i < N; i ++)
	{
		S.insert(i);
		
		while(* S.begin() != i)
		{
		int temp = * S.begin();
			
			parent[temp] = true;
			child[i].push_back(temp);
			
			S.erase(S.begin());
		}
	}
	
	S.clear();
	jumps = new int[N];
	ans = new int[N];
	path = new int[N];
	
	for(int i = 0; i < N; i ++)
		scanf("%d", & jumps[i]);
	
	for(int i = 0; i < N; i ++)
	{
		if(!parent[i])
		{
			DFS(i);
		}
	}
	
	for(int i = 0; i < N; i ++)
		if(i + 1 == N) printf("%d\n", ans[i]);
		else printf("%d ", ans[i]);
	
//	delete child;
//	delete parent;
//	delete jumps;
//	delete height;
//	delete ans;
//	delete path;
	
#ifdef DEBUG
	fprintf(stderr, "RUN TIME: %.5lf\n", double(clock()) / double(CLOCKS_PER_SEC));
	system("pause");
#endif
	
	return 0;
}


/*
TEST 0:
8
3 1 4 5 6 2 3 8
1 2 1 3 4 2 1 2
Answer: 


TEST 1:
6
7 8 9 1 2 3
2 2 2 2 2 2
Answer: 



*/
