/*
TASK:diamonds
LANG:C++
*/
#include <iostream>
#include <cstdio>
using namespace std;

#define MAXD 101

int L, M, N;

int inp[MAXD][MAXD][MAXD];

int DP[MAXD][MAXD][MAXD];

int main()
{
 memset(DP, 0, sizeof(DP));
 
 scanf("%d%d%d", &L, &M, &N);
 
 for (int i = 1; i <= N; i++)
  for (int j = 1; j <= M; j++)
   for (int k = 1; k <= L; k++)
   {
    scanf("%d", &inp[i][j][k]);
    DP[i][j][k] = inp[i][j][k];
    DP[i][j][k] += DP[i - 1][j][k] + DP[i][j - 1][k] + DP[i][j][k - 1];
    
    DP[i][j][k] -= DP[i][j - 1][k - 1];    
    DP[i][j][k] += DP[i - 1][j - 1][k - 1];
    
    DP[i][j][k] -= DP[i - 1][j - 1][k];
    DP[i][j][k] -= DP[i - 1][j][k - 1];
   }
 
 int x1, x2, y1, y2, z1, z2, ans;
 
 while (scanf("%d%d%d%d%d%d", &x1, &y1, &z1, &x2, &y2, &z2) != -1)
 {
  ans = DP[z2][y2][x2];
  
  ans -= DP[z1][y2][x2]; 
  
  ans -= DP[z2][y2][x1]; 
  
  ans -= DP[z2][y1][x2];
  ans -= DP[z1][y1][x1];
  
  ans += DP[z2][y1][x1];
  ans += DP[z1][y2][x1];
  ans += DP[z1][y1][x2];
  
  printf("%d\n", ans);
 }
 
 return 0;
}
