/*
TASK: titanic
LANG: C++
*/

#include <iostream>
#include <cmath>

using namespace std;

int mas[1024][1024];
int tab[1024][1024];
int n,m;


void solve(int x,int y)
{
	int max=-(1<<30),mx,my;
	if(x-1>=0&&tab[x-1][y]==0) 
	{
		printf("0 %d %d\n",x-1,y);
		tab[x-1][y]=1;
		scanf("%d",mas[x-1][y]);
	}
	if(x-1>=0&&max<mas[x-1][y]) {max=mas[x-1][y];mx=x-1;my=y;}
	if(y-1>=0&&tab[x][y-1]==0) 
	{
		printf("0 %d %d\n",x,y-1);
		tab[x][y-1]=1;
		scanf("%d",mas[x][y-1]);
	}
	if(y-1>=0&&max<mas[x][y-1]) {max=mas[x][y-1];mx=x;my=y-1;}
	if(x+1<n&&tab[x+1][y]==0) 
	{
		printf("0 %d %d\n",x+1,y);
		tab[x+1][y]=1;
		scanf("%d",mas[x+1][y]);
	}
	if(x+1<n&&max<mas[x+1][y]) {max=mas[x+1][y];mx=x+1;my=y;}
	if(y+1<m&&tab[x][y+1]==0) 
	{
		printf("0 %d %d\n",x,y+1);
		tab[x][y+1]=1;
		scanf("%d",mas[x][y+1]);
	}
	if(y+1<m&&max<mas[x][y+1]) {max=mas[x][y+1];mx=x;my=y+1;}
	if(max<mas[x][y]) 
	{
		printf("0 %d %d",x,y);
		return;
	}
	solve(mx,my);
}


int main()
{
	int x,y;
	scanf("%d %d",&n,&m);
	if(n*m<=3050)
	{
		for(int i=0;i<n;i++)
			for(int j=0;j<m;j++)
			{
				printf("0 %d %d\n",i,j);
				scanf("%d",&mas[i][j]);
			}
		for(int i=0;i<n;i++)
		{
			for(int j=0;j<m;j++)
			{
				if(i-1>=0) if(mas[i-i][j]>=mas[i][j]) continue;
				if(j-1>=0) if(mas[i][j-1]>=mas[i][j]) continue;
				if(i+1<n)  if(mas[i+1][j]>=mas[i][j]) continue;
				if(j+1<m)  if(mas[i][j+1]>=mas[i][j]) continue;
				printf("1 %d %d\n",i,j);
			}	
		}
	}
	else
	{
		int max=-(1<<30),xm,ym;
		int x=(n*m)/1000;
		double y=n/(double)m;
		double z= ((1.0/y)*x);
		double t=sqrt(z);
		int x1=(int)(y*t);
		int y1=(int)(t);
		int bp1=n/x1;
		int bp2=m/y1;
		int mbp=min(bp1,bp2);
		for(int i=1;i<=mbp;i++)
		{
			for(int j=1;j<=mbp;j++)
			{
				printf("0 %d %d\n",i*x1, j*y1);
				tab[i*x1][j*y1]=1;
				scanf("%d",mas[i*x1][j*y1]);
				if(max<mas[i*x1][j*y1]) 
				{
					max=mas[i*x1][j*y1];
					xm=i*x1;
					ym=j*y1;
				}
			}
		}
		solve(xm,ym);
	}
	return 0;
}
