/*
TASK: titanic
LANG: C++
*/

#include <iostream>
using namespace std;

int a[1024][1024];
int have[1024][1024];
int n, m;

inline int min(int a, int b) { return a<b?a:b; }
inline int max(int a, int b) { return a>b?a:b; }

void get_surroundings(int x, int y)
{
	int i, j;
	int e1=min(n-1, x+1), e2=min(m-1, y+1);
	for(i=max(0, x-1); i<=e1; i++)
		for(j=max(0, y-1); j<=e2; j++)
			if(!have[i][j])
				{
					have[i][j]=1;
					cout<<0<<' '<<i<<' '<<j<<endl;
					cin>>a[i][j];
				}
}

inline int cell(int x, int y) { return (0<=x && x<n && 0<=y && y<m); }
int aired(int &x, int &y)
{
	int rx, ry, res=1, max=a[x][y];
	if(cell(x-1, y)) if(a[x-1][y]>max) { rx=x-1; ry=y; res=0; max=a[x-1][y]; }
	if(cell(x+1, y)) if(a[x+1][y]>max) { rx=x+1; ry=y; res=0; max=a[x+1][y]; }
	if(cell(x, y+1)) if(a[x][y+1]>max) { rx=x; ry=y+1; res=0; max=a[x][y+1]; }
	if(cell(x, y-1)) if(a[x][y-1]>max) { rx=x; ry=y-1; res=0; max=a[x][y-1]; }
	if(res) return 1;
	if(cell(x-1, y-1)) if(a[x-1][y-1]>max) { rx=x-1; ry=y-1; max=a[x-1][y-1]; }
	if(cell(x-1, y+1)) if(a[x-1][y+1]>max) { rx=x-1; ry=y+1; max=a[x-1][y+1]; }
	if(cell(x+1, y-1)) if(a[x+1][y-1]>max) { rx=x+1; ry=y-1; max=a[x+1][y-1]; }
	if(cell(x+1, y+1)) if(a[x+1][y+1]>max) { rx=x+1; ry=y+1; max=a[x+1][y+1]; }
	x=rx; y=ry;
	return 0;
}

int main()
{
	cin>>n>>m;
	int x=0, y=0;
	
	do
	{
		//cout<<"I'm here: " <<x<<' '<<y<<endl;
		get_surroundings(x, y);
		//cout<<"Still here: " <<x<<' '<<y<<endl;
		if(aired(x, y)) { cout<<"1 "<<x<<' '<<y<<endl; return 0; }
	} while(1);
	
	return 0;
}
