/*
TASK: boxes
LANG: C++
*/
// Iordan Boev
# include <stdio.h>
# include <iostream>
# include <vector>
# include <queue>
# include <algorithm>
# include <math.h>

using namespace std;

# define fi(A) for(int i = 0; i < A; i++)
# define fj(A) for(int j = 0; j < A; j++)
# define fk(A) for(int k = 0; k < A; k++)
# define repi(A,B) for(int i = A; i < B; i++) 
# define repj(A,B) for(int j = A; j < B; j++)
# define repk(A,B) for(int k = A; k < B; k++)
# define brepi(A,B) for(int i = A-1, i >= B; i--)
# define brepj(A,B) for(int j = A-1; j >= B; j--)
# define mp make_pair
# define pb push_back
# define MAXN (1<<17)

int n;
int a[MAXN];
vector <int> data[2][MAXN];
int used[MAXN];
int p;
int ans;

void bfs(int v) {
    queue <int> q;
    q.push(v);
    used[v] = 2;
    while(!q.empty()) {
        int cur = q.front();
        //printf("cur = %d\n", cur);
        q.pop();
        fi((int)data[p][cur].size()) {
            if(used[data[p][cur][i]] != 2) {
                q.push(data[p][cur][i]);
                used[data[p][cur][i]] = 2;
            }
        }    
    }
}

void work(int v) {
    //printf("wikme work za %d\n", v);
    if(used[v] == 1) {
        //printf("PUSKA ZA %d\n", v);
        bfs(v);
        ans++;
        return;
    }
    used[v] = 1;
    work(a[v]);
}

void solve() {
    repi(1,n+1) {
        if(used[i] == 0) {
            //printf("WIka za %d\n", i);
            work(i);
        }
    }
}

void read() {
    scanf("%d", &n);
    p = 0;
    repi(1,n+1) {
        scanf("%d", &a[i]);
        data[p][a[i]].pb(i);
    }
    solve();
    printf("%d ", ans);
    ans = 0;
    p++;
    fi(n+2) {
        used[i] = 0;
        a[i] = 0;
    }
    scanf("%d", &n);
    repi(1,n+1) {
        scanf("%d", &a[i]);
        data[p][a[i]].pb(i);
    }
    solve();
    printf("%d\n", ans);
}

int main() {
    read();
    return 0;
}
