/*  
TASK: msweeper
LANG: C++
*/
// Iordan Boev
# include <stdio.h>
# include <iostream>
# include <vector>
# include <queue>
# include <algorithm>
# include <math.h>

using namespace std;

# define fi(A) for(int i = 0; i < A; i++)
# define fj(A) for(int j = 0; j < A; j++)
# define fk(A) for(int k = 0; k < A; k++)
# define repi(A,B) for(int i = A; i < B; i++) 
# define repj(A,B) for(int j = A; j < B; j++)
# define repk(A,B) for(int k = A; k < B; k++)
# define brepi(A,B) for(int i = A-1, i >= B; i--)
# define brepj(A,B) for(int j = A-1; j >= B; j--)
# define mp make_pair
# define pb push_back
# define MAXN (1<<14)

struct point {
    int x,y;
} data[MAXN];
int n,r;
int a[MAXN];
int miny,id;
int hull[MAXN];
int crnt;
double ans;

inline int area(point a,point b,point c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y);
}

int cmp(const void *e1,const void *e2) {
    int tarea = area(data[0],data[*(int*)e1],data[*(int*)e2]);
    if(tarea != 0) return -tarea;
    else {
        if(data[*(int*)e1].y != data[*(int*)e2].y) return data[*(int*)e1].y-data[*(int*)e2].y;
        else return data[*(int*)e1].x - data[*(int*)e2].x;
    }
}

void read() {
    miny= -20005;
    scanf("%d %d", &n, &r);
    fi(n) {
        scanf("%d %d", &data[i].x,&data[i].y);
        a[i] = i;
        if(data[i].y < miny || miny == -20005) {
            miny = data[i].y;
            id = i;
        }
        if(data[i].y == miny) {
            if(data[i].x > data[id].x) {
                id = i;
            }
        }
    }
    //printf("%d %d\n", miny,id);
    point tmp;
    tmp.x = data[0].x;
    tmp.y = data[0].y;
    data[0].x = data[id].x;
    data[0].y = data[id].y;
    data[id].x = tmp.x;
    data[id].y = tmp.y;
    qsort(a+1,n-1,sizeof(int), cmp);
    /*fi(n) {
        printf("%d %d\n", data[a[i]].x,data[a[i]].y);
    }
    printf("\n");*/
}

double dist(point a,point b) {
    return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

void makehull() {
    hull[0] = a[0];
    hull[1] = a[1];
    hull[2] = a[2];
    crnt = 3;
    repi(3,n) {
        hull[crnt] = a[i];
        while( area(data[hull[crnt-2]], data[hull[crnt-1]],data[hull[crnt]]) < 0) {
            crnt--;
            hull[crnt] = a[i];
        }
        crnt++;
    }
    hull[crnt] = hull[0];
    //fi(crnt) printf("%d %d\n", data[hull[i]].x,data[hull[i]].y);
    fi(crnt) {
        ans+= dist(data[hull[i]],data[hull[i+1]]);  
    }
    ans+=2*M_PI*r;
    printf("%lf\n", ans);
}

int main() {
    read();
    makehull();
    return 0;
}
