/*
TASK: titanic
LANG: C++
*/
#include <iostream>
#include <fstream>
using namespace std;

int K;

int N, M;
int R[1000][1000];

void init()
{
     ifstream fin("titanic.in");
     for (int i = 0; i < N; i++) for (int j = 0; j < M; j++) fin >> R[i][j];
     for (int i = 498; i < 503; i++)
     {
         for (int j = 498; j < 503; j++)
          cout << R[i][j] << " ";
         cout << endl;
     }
} 
int movei[4] = { -1,  0, 1,  0 };
int movej[4] = {  0,  1, 0, -1 };

void getNM()
{
    cin >> N >> M;
    //N = 1000, M = 1000;
}

bool isgood(int m, int a, int b, int c, int d)
{
     return m > a && m > b && m > c && m > d;
}

int ask(int i, int j)
{
    if (j < 0 || i >= N || i < 0 || j >= M) return -1;
    if (R[i][j] != -1) return R[i][j];
    
    if (K == 3050) { return -1; }
    K++;
    
    cout << "0 " << i << " " << j << endl;
    cin >> R[i][j];
    return R[i][j];
}

void ask2(int i, int j, int dir, int h)
{
     int maxx = -1, newdir;
     for (int m = -1; m < 2; m++)
     {
         int newi = i + movei[(dir+m + 4)%4];
         int newj = j + movej[(dir+m + 4)%4];
         
         int here = ask(newi, newj);
         
         if (here > maxx) maxx = here, newdir = (dir+m + 4)%4;
     }
     
     if (maxx < h) { cout << "1 " << i << " " << j << endl; return; }
     ask2(i + movei[newdir], j + movej[newdir], newdir, maxx);
         
}
int main()
{
    getNM();
    memset(R, -1, sizeof(R));
    
    
    //init();
    
    
    
    int i = N/2, j = M/2;
    int my, left = -1, right = -1, top = -1, bottom = -1;
    my = ask(i, j);
    top = ask(i-1, j);
    right = ask(i, j+1);
    bottom = ask(i+1, j);
    left = ask(i, j-1);
    
    //cout << my << " " << top << " " << right << " " << bottom << " " << left << endl;
    if (isgood(my, top, right, bottom, left)) { cout << "1 " << i << " " << j << endl; return 0; }
    
    if (top > right && top > bottom && top > left) ask2(i-1, j, 0, top);
    else if (bottom > top && bottom > right && bottom > left) ask2(i+1, j, 2, bottom);
    else if (left > top && left > bottom && left > right) ask2(i, j-1, 3, left);
    else ask2(i, j+1, 1, right);
    
    return 0;
}
