/*
TASK:boxes
LANG:C++
*/
#include <iostream>
using namespace std;
struct graph
{
int next[100100];
int to[100100];
int start[100100];
int m;

};
graph g1, g2;
int used1[100100];
int used2[100100];

int a[100100], br;
int in[100100];
int n;

void add_edge (int u, int v)
{
	g1.to[++g1.m] = v;
	g1.next[g1.m] = g1.start[u];
	g1.start[u] = g1.m;
	
	g2.to[++g2.m] = u;
	g2.next[g2.m] = g2.start[v];
	g2.start[v] = g2.m;
	
}
void dfs1( int pos)
{
	used1[pos] = 1;
	int i;
	for (i = g1.start[pos]; i!=-1; i = g1.next[i])
		if (!used1[g1.to[i]]) dfs1(g1.to[i]);
	
	a[br++] = pos;	
}

void dfs2( int pos, int cc)
{
	used2[pos] = cc;
	int i;
	for (i = g2.start[pos]; i!=-1; i = g2.next[i])
		if (!used2[g2.to[i]]) dfs2(g2.to[i], cc);	
}

void solve ()
{
	
	memset(g1.start, -1, sizeof (g1.start));
	memset(g2.start, -1, sizeof (g2.start));
	memset(in, 0, sizeof (in));
	memset(used1, 0, sizeof (used1));
	memset(used2, 0, sizeof (used2));
	
	g1.m = g2.m = -1;
	br = 0;
	scanf ("%d", &n);
	
	int i;
	int u;
	for (i = 1;i<=n;i++)
	{
		scanf ("%d", &u);
		add_edge(u, i);
	}
	
	for (i = 1;i<=n;i++)
	{
		if (!used1[i]) dfs1(i);
	}
	
	int res =0;
	int strong = 1;
	for (i = br-1; i>=0; i--)
	{ //cout <<a[i] <<" "; 
		if (!used2[ a[i] ]) {dfs2(a[i], strong);strong++;}
	}
	
	int j;
	for (i = 1;i<=n;i++)
	{ //cout <<used2[i]<<" ";
		for (j = g1.start[i]; j!=-1; j = g1.next[j])
		{
			if (used2[i] != used2[g1.to[j]]) in[used2[g1.to[j]]] ++;
		}
		
	}
	
	for (i = 1;i<strong;i++) if (in[i] == 0) res++;
	
	printf ("%d", res);
	
}
int main ()
{
	
	solve (); printf(" ");
	solve ();printf ("\n");
	//solve ();
	return 0;
}
