/*
TASK:msweeper
LANG:C++
*/
#include <iostream>
#include <cmath>
using namespace std;

struct point
{
	long long x, y;
	
	void read ()
	{
		scanf ("%d%d", &x, &y);
	}
};

int n; double R;
point a[20000];
point b[20000];

double dist (point p1, point p2)
{
	return sqrt((double)((p1.x - p2.x)*(p1.x - p2.x) + (p1.y - p2.y)*(p1.y - p2.y))); 
}

long long DDD(point p0, point p1, point p2)
{
	return (p1.x - p0.x) * (p2.y - p0.y) - (p2.x - p0.x) * (p1.y - p0.y);
}
bool cmp (point p1, point p2)
{
	long long opa = DDD(a[0], p1, p2);
	 
	if (opa == 0) return p1.x < p2.x; 
		return opa > 0;
	
}
void solve ()
{
	
	scanf ("%d%lf", &n, &R);
	double res = 2.0 * M_PI * R;
	int i;
	for (i =0;i<n;i++) 
	{
		a[i].read();
	if (a[i].x < a[0].x) swap(a[i], a[0]);
		else
	if (a[i].x == a[0].x && a[i].y < a[0].y) swap(a[i], a[0]);
		 
	}
	
	if (n == 1) {printf("%.7lf\n", res); return;}
	
	sort (a+1, a+n, cmp);
	if (DDD(a[0], a[1], a[n-1]) == 0) 
	{
		res+= 2.0*dist (a[0], a[n-1]);
		printf ("%.7lf\n", res);
		return;
	}
	a[n] = a[0];
	
	b[0] = a[0];
	b[1] = a[1];
	int br = 2;
	for (i = 2; i <= n; i++)
		{
			while (br > 1 && DDD(b[br-2], b[br-1], a[i]) <= 0) br--;
			b[br++] = a[i];	
		}
		
	//	cout << br << endl;
   for (i = 0; i < br-1; i++)
   {
	  // printf ("(%d, %d) ", b[i].x, b[i].y);
	   res += dist(b[i], b[i+1]);
   }
   
   //cout<<endl;
   printf ("%.7lf\n", res);
	
}
int main ()
{
	
	double res = 0;
	
	// P = 2* Pi * R;
	
	solve ();
	
	
	
	
	
	return 0;
	
}
