/*
TASK: boxes
LANG: C++
*/
#include <stdio.h>
#include <vector>
#define MAXN ( 1 << 17 )
using namespace std;

int n , t , used[ MAXN ] , br , in [ MAXN ] , sol;
vector < int > a[ MAXN ] , cyc ;

void dfs (int v)
{
 int push = -1;
 used [v] = -2;
// printf ("in %d\n", v);
 for (int i=0; i < a[v].size(); ++i)
  {
   int nv = a[v][i];
//   printf ("pri v = %d , nv -> %d , used e %d\n", v , nv, used[nv]);   
   if ( used[nv] == -2 ) push = nv;
   if ( used[nv] == -1 ) dfs (nv);
  }

 if ( push != -1 ) cyc.push_back ( push ) , ++br; 
 if ( cyc.size() ) 
  {
   used[v] = br;
   if ( cyc[0] == v ) cyc.pop_back ();
  }
 else used[v] = ++br;
}

inline void solve ()
{ 
 cyc.clear (); sol = 0; br = 0;
 memset ( in , 0 , sizeof (in));
 memset ( used , -1, sizeof (used));
  
 for (int i=1; i <= n; ++i)
  if ( used[i] == -1 ) 
   dfs ( i );
/*   
 printf ("%d\n", br);
 for (int i=1 ; i <= n; ++i)
  printf ("%d ", used[i] );
 printf ("\n");
*/ 
 for (int i=1; i <= n; ++i)
  for (int j=0; j < a[i].size(); ++j)
   if (used[i] != used[ a[i][j] ])
     in [ used[ a[i][j] ] ] ++;
   
 for (int i=1; i <= br ; ++i)
  if ( !in [i] )
   sol ++;
 
 printf ("%d", sol);
}

int main ()
{
 for (int i=0 ; i < 2; ++i)
  {
   scanf ("%d", &n);
   for (int j=1; j <= n; ++j)
    a[j].clear ();
   
   for (int j=1; j <= n; ++j)
    scanf ("%d", &t) , a[t].push_back (j);
   
   solve ();
   printf ("%c", i? '\n': ' '); 
   //printf ("%lf\n", (double) clock () / (double)CLOCKS_PER_SEC);
  }
 return 0;    
}
