/*
TASK: titanic
LANG: C++
*/
#define Repi(n) for(int i=0;i<(n);i++)
#define Repj(n) for(int j=0;j<(n);j++)
#define Repk(n) for(int k=0;k<(n);k++)
#define mp make_pair
#define pb push_back

#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

int Table[1000][1000];

int z,q,k;

bool Check(int x,int y){
     int res=0;
     if(Table[x][y]==-1){return 0;}
     if(y==0){res++;}else if(Table[x][y-1]!=-1 && Table[x][y]>Table[x][y-1]){res++;}
     if(y+1==q){res++;}else if(Table[x][y+1]!=-1 && Table[x][y]>Table[x][y+1]){res++;}
     if(x==0){res++;}else if(Table[x-1][y]!=-1 && Table[x][y]>Table[x-1][y]){res++;}
     if(x+1==z){res++;}else if(Table[x+1][y]!=-1 && Table[x][y]>Table[x+1][y]){res++;}
     if(res==4)return 1;
     return 0;}

void Ask(int x,int y){
     k++;
     cout<<"0 "<<x<<" "<<y<<endl;
     //cin>>Table[x][y];
     scanf ("%d",&Table[x][y]);
     return;}

int main(){

    cin>>z>>q;
    
    memset(Table,-1,sizeof(Table));
    
    //Greedy 0 (Angles) (12 ?s)
    if(Table[0][1]==-1){Ask(0,1);}
    if(Table[1][0]==-1){Ask(1,0);}
    if(Table[0][0]==-1){Ask(0,0);if(Check(0,0)==1){cout<<"1 0 0\n";return 0;}}
    if(Table[z-2][q-1]==-1){Ask(z-2,q-1);}
    if(Table[z-1][q-2]==-1){Ask(z-1,q-2);}
    if(Table[z-1][q-1]==-1){Ask(z-1,q-1);if(Check(z-1,q-1)==1){cout<<"1 "<<z-1<<" "<<q-1<<endl;return 0;}}
    if(Table[z-2][0]==-1){Ask(z-2,0);}
    if(Table[z-1][1]==-1){Ask(z-1,1);}
    if(Table[z-1][0]==-1){Ask(z-1,0);if(Check(z-1,0)==1){cout<<"1 "<<z-1<<" 0"<<endl;return 0;}}
    if(Table[1][q-1]==-1){Ask(1,q-1);}
    if(Table[0][q-2]==-1){Ask(0,q-2);}
    if(Table[0][q-1]==-1){Ask(0,q-1);if(Check(0,q-1)==1){cout<<"1 0 "<<q-1<<endl;return 0;}}

    //Greedy 1 (Square Extend) (576 ?s max) 
    int m=25;
    for(int i=0;i<m;i++){
            for(int j=0;j<=min(i,z-1);j++){
                    for(int k=0;k<=min(i,q-1);k++){
                            if(Table[j][k]==-1){
                              Ask(j,k);
                              if(Check(j,k)==1){
                                              cout<<"1 "<<j<<" "<<k<<endl;
                                              //cout<<Table[j][k]<<endl;
                                              //system("pause");
                                              return 0;}}}}
            for(int j=0;j<=min(i,z-1);j++){
                    for(int k=0;k<=min(i,q-1);k++){
                            if(Check(j,k)==1){
                                              cout<<"1 "<<j<<" "<<k<<endl;
                                              //cout<<Table[j][k]<<endl;
                                              //system("pause");
                                              return 0;}}}}
    
    //Greedy 2 (1/3->) (576 ?s max)
    for(int i=0;i<25;i++){
            for(int j=z/3;j<=min(z/3+i,z-1);j++){
                    for(int k=q/3;k<=min(q/3+i,q-1);k++){
                            if(Table[j][k]==-1){
                              Ask(j,k);
                              if(Check(j,k)==1){
                                              cout<<"1 "<<j<<" "<<k<<endl;
                                              //cout<<Table[j][k]<<endl;
                                              //system("pause");
                                              return 0;}}}}
            for(int j=0;j<=min(i,z-1);j++){
                    for(int k=0;k<=min(i,q-1);k++){
                            if(Check(j,k)==1){
                                              cout<<"1 "<<j<<" "<<k<<endl;
                                              //cout<<Table[j][k]<<endl;
                                              //system("pause");
                                              return 0;}}}}

    //Greedy 3 (2/3->) (576 ?s max)
    for(int i=0;i<25;i++){
            for(int j=2*z/3;j<=min(2*z/3+i,z-1);j++){
                    for(int k=2*q/3;k<=min(2*q/3+i,q-1);k++){
                            if(Table[j][k]==-1){
                              Ask(j,k);
                              if(Check(j,k)==1){
                                              cout<<"1 "<<j<<" "<<k<<endl;
                                              //cout<<Table[j][k]<<endl;
                                              //system("pause");
                                              return 0;}}}}
            for(int j=0;j<=min(i,z-1);j++){
                    for(int k=0;k<=min(i,q-1);k++){
                            if(Check(j,k)==1){
                                              cout<<"1 "<<j<<" "<<k<<endl;
                                              //cout<<Table[j][k]<<endl;
                                              //system("pause");
                                              return 0;}}}}

    //Greedy 4 (Extend Greedy 1 if possible)
    for(int j=0;j<z;j++){
            for(int k=0;k<q;k++){
                    if(Check(j,k)==1){
                            cout<<"1 "<<j<<" "<<k<<endl;
                            //cout<<Table[j][k]<<endl;
                            //system("pause");
                            return 0;}}}

    //Greedy 5 (If ?-s left - go back)
    if(k<3050){
            for(int j=z;j>0;j--){
                   for(int k=q;k>0;k--){
                            if(Table[j][k]==-1){Ask(j,k);}
                            if(Check(j,k)==1){
                                              cout<<"1 "<<j<<" "<<k<<endl;
                                              //cout<<Table[j][k]<<endl;
                                              //system("pause");
                                              return 0;}}}}
    
    //cout<<k<<" quastions\n";
    //system("pause");
    return 0;}
