/*
TASK:titanic
LANG:C++
*/

#include<cstdio>
#include<cstdlib>
#include<climits>

int t[1024][1024];
int n,m;
int queries;
	
void ask(int x, int y) {
	if(x<0||y<0||x>=n||y>=m) return;
	if(t[x][y]==INT_MIN&&queries<3050) {
	//ask engine;
	printf("0 %d %d\n",x,y);
	scanf("%d",&t[x][y]);
	//end of ask engine
	++queries;
	}
}

char checked[1024][1024];

bool check(int x, int y) {
	if(x<0||y<0||x>=n||y>=m) return false;
	if(checked[x][y]==2) return true;
	else if (checked[x][y]==1) return false;
	
	ask(x,y);
	ask(x-1,y);
	ask(x,y-1);
	ask(x+1,y);
	ask(x,y+1);
	
	bool ok=true;
	if(x-1>=0&&t[x-1][y]>t[x][y]) ok=false;
	if(x+1<n&&t[x+1][y]>t[x][y]) ok=false;
	if(y-1>=0&&t[x][y-1]>t[x][y]) ok=false;
	if(y+1<m&&t[x][y+1]>t[x][y]) ok=false;
	
	checked[x][y]=1+ok;
	return checked[x][y]-1;
}

int main() {
	
	for(int i=0;i<1024;++i) for(int j=0;j<1024;++j) {checked[i][j]=0;t[i][j]=INT_MIN;}
	queries=0;
	scanf("%d%d",&n,&m);
	
	if( m*n <= 3050) {
		for(int i=0;i<n;++i) {
			for(int j=0;j<m;++j) {
				if(check(i,j)) {
					printf("1 %d %d\n",i,j);
					return 0;
				}
			}	
		}	
	}
	
	
	int q1=m*2000/(m+n),q2=n*2000/(m+n);
	
	srand(4875);
	int x,y;
	
	while(queries<q1) {
		x=(rand()%2)*(n-1);
		y=rand()%m;
		if(check(x,y)) {printf("1 %d %d\n",x,y);return 0;}
	}
	while(queries<q1+q2) {
		x=rand()%n;
		y=(rand()%2)*(m-1);
		if(check(x,y)) {printf("1 %d %d\n",x,y);return 0;}
	}
	
	while(queries<3050) {
		x=rand()%n;
		y=rand()%m;
		if(check(x,y)) {printf("1 %d %d\n",x,y);return 0;}
	}
	return 0;
}
