/*
TASK: boxes
LANG: C++
*/
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <utility>
#include <vector>
#include <queue>
#include <stack>
using namespace std;

const int MAX_N = 1 << 17;

int N, left;
int ans[2];
int kids[MAX_N];
vector< int > un[MAX_N];
vector< int > start;
int parent[MAX_N];
bool used[MAX_N], is_in[MAX_N];
priority_queue< pair<int,int> > pq;

void fill(int v){
     used[v]=1;
     for(int i=0; i<un[v].size(); ++i)
             if(!used[un[v][i]]) fill(un[v][i]);
     }

void goIn(int v){
     used[v]=1;
     for(int i=0; i<un[v].size(); ++i){
             if( !used[un[v][i]] ) { goIn(un[v][i]); }
             if(un[v][i]!=v)kids[v] += 1 + kids[un[v][i]];
             }
     }

int main(){
    for(int t=0; t<2; ++t){
            scanf ("%d",&N);
            for(int i=0; i<MAX_N; ++i) un[i].clear();
            start.clear();
            memset(used,0,sizeof(used));
            memset(is_in,0,sizeof(is_in));
            memset(kids,0,sizeof(kids));
            int a;
            for(int i=1; i<=N; ++i){
                    scanf ("%d",&a);
                    un[a].push_back(i);
                    parent[i] = a;
                    if( a==i ) { start.push_back(i); is_in[i]=1; }
                    }
            
            memset(used,0,sizeof(used));
            
            for(int i=1; i<=N; ++i){
                    if( !used[i] ){
                        goIn(i);
                        } 
                    }
                    
             for(int i=1; i<=N; ++i){
                     pq.push ( make_pair( kids[i] , i ) );
                     }          
                     
             memset(used,0,sizeof(used));
                    
//            for(int i=1; i<=N; ++i) printf("%d ",kids[i]);
//            for(int i=0; i<start.size(); ++i) printf("%d ",start[i]); printf("\n");
            for(int i=0; i<start.size(); ++i){
                    if( !used[start[i]] ) { ++ans[t]; fill(start[i]); }
                    }
            pair<int,int> top;
            while( !pq.empty() ){
                   top = pq.top(); pq.pop();
                   if(!used[top.second]){ ++ans[t]; fill(top.second); }
                   }
            }
//    printf("%d\n",MAX_N);
    printf ("%d %d\n",ans[0],ans[1]);
}
