/*
TASK: boxes
LANG: C++
*/

#include <cstdio>
#include <queue>
#include <vector>

using namespace std;

int n;
vector<int> A[100001];
queue<int> q;
bool used[100001];
bool base[100001];

void init()
{
 int i,tmp;
 for(i=1;i<=n;i++) A[i]=vector<int> ();
 for(i=1;i<=n;i++) { scanf("%d",&tmp); A[tmp].push_back(i); }  
 memset(base,0,sizeof(base));
}

int solve()
{
 init();     
 int i,tmp,res=0,to,j;
 for(i=1;i<=n;i++)
    if(!base[i]) 
    {
      memset(used,0,sizeof(used));
      used[i]=1; q.push(i);
      while(!q.empty())
      { tmp=q.front(); q.pop();
        to=A[tmp].size();
        for(j=0;j<to;j++)
           if(!used[A[tmp][j]]) { used[A[tmp][j]]=1; base[A[tmp][j]]=1; q.push(A[tmp][j]); }
     }
    }
 for(i=1;i<=n;i++) if(!base[i]) res++;
 return res;
}

int main()
{
 scanf("%d",&n);   
 int p1=solve();
 int p2=solve();
 
 printf("%d %d\n",p1,p2);

 return 0;
}
