/*
TASK:boxes
LANG:C++
*/
#include <iostream>
#include <vector>
#include <queue>
using namespace std;
void init(int n,vector <int>v[])
{
     for(int i=1;i<=n;i++)
      {
             int k;
             cin>>k;
             v[k].push_back(i);
             v[i].push_back(k);
      }
}

int check(int n,bool used[])
{
     for(int i=1;i<=n;i++)
      if(used[i]==0)return i;
     return -1;
}

int sol[3]={0,0,0};

void bfs(int n,vector <int> v[],int nsol)
{
     bool used[100000];
     for(int i=1;i<=n;i++)
      used[i]=0;
      int ch=check(n,used);
      queue<int> q;
     while(ch!=-1)
     {
        
        q.push(ch);
        used[ch]=1;
        while(!q.empty())
        {
             
             int tmp=q.front();
             q.pop();
             for(int i=0;i<v[tmp].size();i++)
             {       
                     if(used[v[tmp][i]]==0)
                     {used[v[tmp][i]]=1;
                      q.push(v[tmp][i]);
                     }
             }
        }
        sol[nsol]++;
        ch=check(n,used);     
     }
}


int main()
{
    for(int i=0;i<2;i++)
    {
    int n;
    vector <int> v[100000];
    cin>>n; 
    init(n,v);
    bfs(n,v,i+1);                       
    }
    cout<<sol[1]<<" "<<sol[2]<<endl;
    
    return 0;
}
