/*
TASK: msweeper
LANG: C++
*/
#include<iostream>
#include<math.h>
#define MAXN 11000
using namespace std;
typedef struct point
{
int x;
int y;
};

double dist(point p1, point p2)
{
return sqrt( (p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
}

point p[MAXN];
point s;

int n,r;

 int det(point p1,point p2,point p3)
 {
 return p1.x*(p2.y-p3.y)+p2.x*(p3.y-p1.y)+p3.x*(p1.y-p2.y);
 }
 
 bool cmp(point a,point b)
 {
 int d1,d2;
 d1=det(a,b,s);
 d2=det(b,a,s);
 
 if(d1<d2)return 1;
 if(d1==d2)
  {
  if(dist(a,s)<dist(b,s))return 0;
  return 1;
  }
 return 0;
 }

int main()
{
int i,j,a,b,mini=0,br;
double ans=0;
int con[MAXN];
memset(con,0,sizeof(con));

scanf("%d%d",&n,&r);

 for(i=0;i<n;i++)
 {
 scanf("%d%d",&a,&b);
 p[i].x=a;
 p[i].y=b;
 }

 for(i=1;i<n;i++)
 {
 if(p[i].x<p[mini].x)mini=i;
 else if(p[i].x==p[mini].x&&p[i].x<p[mini].y)mini=i;
 }
 s=p[mini];
 swap(p[mini],p[0]);
 //printf("%d %d",s.x,s.y);
 sort(p+1,p+n,cmp);
 //for(i=0;i<n;i++)
 //printf("%d %d\n",p[i].x,p[i].y);
 //printf("\n");
 p[n]=p[0];
 br=2;
 for(i=2;i<n;i++)
 {
 while(det(p[br-2],p[br-1],p[i])>=0)br--;
 swap(p[br],p[i]);
 br++;
 }
 p[br]=p[0];
 //for(i=0;i<=br;i++)
 //printf("%d %d\n",p[i].x,p[i].y);
 
  for(i=1;i<=br;i++)
  ans+=dist(p[i-1],p[i]);
  ans=ans+2*M_PI*r;
  printf("%lf\n",ans);
return 0;
}
