/*
TASK: boxes
LANG: C++
*/

#include <cstdio>
#include <vector>

int n;
std::vector <std::vector <int> > g;
std::vector <bool> used;
int x;
int res;

void dfs(int x) {
	//printf("%d\n\t", x);
	used[x] = true;
	
	for(int i = 0; i < g[x].size(); ++i) {
		if(!used[g[x][i]]) {
			dfs(g[x][i]);
		}
	}
}

int solve() {
	res = 0;
	
	g = std::vector <std::vector <int> >();
	used = std::vector <bool>();
	
	scanf("%d", &n);
	g.resize(n+1);
	used.resize(n+1, 0);
	
	for(int i = 1; i <= n; ++i) {
		scanf("%d", &x);
		g[x].push_back(i);
		g[i].push_back(x);
	}
	
	for(int i = 1; i <= n; ++i) {
		if(!used[i]) {
			dfs(i);
			++res;
		}
	}
	
	return res;
}

int main() {
	printf("%d ", solve());
	printf("%d\n", solve());
	
	return 0;
}
