/*
TASK: titanic
LANG: C++
*/

#include <cstdio>

int n, m;
int roof[1024][1024];
int k;

bool ok(int i, int j) {
	 if(i > 0 && roof[i][j] < roof[i-1][j]) {
	 	return false;
	 }
	 if(j > 0 && roof[i][j] < roof[i][j-1]) {
	 	return false;
	 }
	 if(i < n-1 && roof[i][j] < roof[i+1][j]) {
	 	return false;
	 }
	 if(j < m-1 && roof[i][j] < roof[i][j+1]) {
	 	return false;
	 }
	 
	 return true;
}

int min(int a, int b) {
	return a < b ? a : b;
}

void ask(int a, int b) {
	printf("0 %d %d\n", a, b);
	scanf("%d", &roof[a][b]);
}

int main() {
	scanf("%d%d", &n, &m);
	
	for(int i = 0; i < n; ++i) {
		for(int j = 0; j < m; ++j) {
			roof[i][j] = 9999999;
		}
	}
	
	for(int i = 0; i < n; ++i) {
		for(int j = i; j >= 0; --j) {
			ask(min(j, n-1), min(i-j, m-1));
			if(++k >= 3050)
				break;
		}
	}
	
	for(int i = 0; i < n; ++i) {
		for(int j = 0; j < m; ++j) {
			if(ok(i, j)) {
				printf("1 %d %d\n", i, j);
				break;
			}
		}
	}
	
	
	return 0;
}
