/*
TASK:msweeper
LANG:C++
*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#define v_pi 3.1415926535897932384626
#define max_n 1000000000
using namespace std;
struct pointp{
  int x,y;
  bool operator<(const pointp& w) const{
    if(y<w.y) return true;
    if((y==w.y)&&(x<w.x)) return true;
    return false;
                                }
};
vector<pointp> data;
///////////
int lowx,lowy;
int find_or_s(int fx,int fy,int sx,int sy,int tx,int ty){
  long long S=((long long)fx-sx)*((long long)fy+sy)+((long long)sx-tx)*((long long)sy+ty)+((long long)tx-fx)*((long long)ty+fy);
  if(S>0) return 1;
  if(S<0) return -1;
  return 0;
}
struct point{
  int x,y;
  point(int a,int b){
    x=a;y=b;
                    }
  point(){}
  bool operator<(const point& w) const{
    if((x==lowx)&&(y==lowy)) return true;
    if((w.x==lowx)&&(w.y==lowy)) return false;
    int S=find_or_s(lowx,lowy,x,y,w.x,w.y);
    if(S>0) return true;
    if(S<0)  return false;
    if(x<w.x) return true;
    return false;
                                      }
};
vector<point> vhod;
vector<point> obvivka;
int n;
double r;
inline double get_rast(point f,point s){
  return sqrt(((long long)(f.x)-s.x)*((long long)(f.x)-s.x)+((long long)(f.y)-s.y)*((long long)(f.y)-s.y));
}
int main(){
  //system("pause");
  scanf("%ld%lf",&n,&r);
  int i,j,k,l;
  point tek;
  point low;
  pointp tek1;
  for(i=0;i<n;i++){
    scanf("%ld%ld",&tek1.x,&tek1.y);
    data.push_back(tek1);
                  }
  sort(data.begin(),data.end());
  vhod.push_back(point(data[0].x,data[0].y));
  for(i=1;i<n;i++)
    if((data[i].x!=data[i-1].x)||(data[i].y!=data[i-1].y)) vhod.push_back(point(data[i].x,data[i].y));
  //cout<<endl<<endl;
  //for(i=0;i<vhod.size();i++) cout<<vhod[i].x<<' '<<vhod[i].y<<endl;
  if(vhod.size()==1){
    printf("%.12lf\n",2.0*v_pi*r);
    //system("pause");
    return 0;
                    }
  if(vhod.size()==2){
    printf("%.12lf\n",get_rast(vhod[0],vhod[1])+2.0*v_pi*r);
   //system("pause");
    return 0;
                    }
  low=vhod[0];
  for(i=1;i<vhod.size();i++){
    if(vhod[i].y<low.y) low=vhod[i];
    else{
      if((vhod[i].y==low.y)&&(vhod[i].x<low.x)) low=vhod[i];
        }
                  }
  lowx=low.x;lowy=low.y;
  sort(vhod.begin(),vhod.end());
  int pos=vhod.size()-1;
  while(1){
    if(pos==0) break;
    if(find_or_s(lowx,lowy,vhod[pos].x,vhod[pos].y,vhod[pos-1].x,vhod[pos-1].y)!=0) break;
    pos--;
          }
  j=vhod.size()-1;
  for(i=pos;i<=((pos+vhod.size()-1)/2);i++){
    tek=vhod[i];
    vhod[i]=vhod[j];
    vhod[j]=tek;
    j--;
                                           }
  obvivka.push_back(vhod[0]);
  obvivka.push_back(vhod[1]);
  for(i=2;i<vhod.size();i++){
    while(1){
      if(obvivka.size()<=1) break;
      if(find_or_s(obvivka[obvivka.size()-2].x,obvivka[obvivka.size()-2].y,
      obvivka[obvivka.size()-1].x,obvivka[obvivka.size()-1].y,vhod[i].x,vhod[i].y)>0) break;
      obvivka.pop_back();
            }
      obvivka.push_back(vhod[i]);
                            }
  double S=0;
  for(i=0;i<obvivka.size()-1;i++){
    S+=get_rast(obvivka[i],obvivka[i+1]);
                                 }
  S+=get_rast(obvivka[obvivka.size()-1],obvivka[0]);
  S+=2.0*v_pi*r;
  printf("%.12lf\n",S);
  //system("pause");
  return 0;
}
