/*
TASK: titanic
LANG: C++
*/

#include <cstdio>

const int MAX_SIZE = 1 << 10;

int m, n, xans, yans;
int a[MAX_SIZE][MAX_SIZE];
bool used[MAX_SIZE][MAX_SIZE];

void ask (int xcoor, int ycoor) {
    printf("0 %d %d\n", xcoor, ycoor);
    scanf("%d", &a[xcoor][ycoor]);
    used[xcoor][ycoor] = true;
}

void check (int x, int y) {
    if (xans >= 0 && yans >= 0) return;

    if (!used[x][y]) ask(x,y);
    xans = x; yans = y;
    if (x > 0) {
    if (!used[x-1][y]) ask(x-1,y);
    if (a[x][y] < a[x-1][y]) { xans = yans = -1; check(x-1,y); }
    }
    if (x+1 < n) {
    if (!used[x+1][y]) ask(x+1,y);
    if (a[x][y] < a[x+1][y]) { xans = yans = -1; check(x+1,y); }
    }
    if (y > 0) {
    if (!used[x][y-1]) ask(x,y-1);
    if (a[x][y] < a[x][y-1]) { xans = yans = -1; check(x,y-1); }
    }
    if (y+1 < m) {
    if (!used[x][y+1]) ask(x,y+1);
    if (a[x][y] < a[x][y+1]) { xans = yans = -1; check(x,y+1); }
    }
}

int main () {
    scanf("%d%d", &n, &m);
    xans = -1; yans = -1;
    check(n>>1,m>>1);
    printf("1 %d %d\n", xans, yans);

    return 0;
}
