/*
task:titanic
lang:c++
*/
#include<iostream>
#include<cstdio>
#include<queue>
using namespace std;
struct coord{
       int x,y,d;
       coord(){};
       coord(int a,int b,int c){x=a;y=b;d=c;}
       bool operator<(const coord &b)const{
            return d>b.d;
            }
       };
int a[1024][1024],b[1024][1024]={0},n,m;

bool valid(int x,int y){
     //cout << "v " << x << ' ' << y << endl;
     if(x>=0 && x<n && y>=0 && y<m) return true;
     //cout << "un " << x << ' ' << y << endl;
     return false;
     }
     
int brvalid(int x,int y){
    int br=0;
    if(valid(x-1,y)) br++;
    if(valid(x+1,y)) br++;
    if(valid(x,y-1)) br++;
    if(valid(x,y+1)) br++;
    //cout << "brv " << br << endl;
    return br;
}

vector<coord> get_av_neigh(coord c){
              vector<coord> res;
              if(valid(c.x-1,c.y) && b[c.x-1][c.y]==1) res.push_back(coord(c.x-1,c.y,0));
              if(valid(c.x+1,c.y) && b[c.x+1][c.y]==1) res.push_back(coord(c.x+1,c.y,0));
              if(valid(c.x,c.y-1) && b[c.x][c.y-1]==1) res.push_back(coord(c.x,c.y-1,0));
              if(valid(c.x,c.y+1) && b[c.x][c.y+1]==1) res.push_back(coord(c.x,c.y+1,0));
              return res;
              } 
              
vector<coord> get_un(coord c){
              vector<coord> res;
              if(valid(c.x-1,c.y) && b[c.x-1][c.y]==0) res.push_back(coord(c.x-1,c.y,0));
              if(valid(c.x+1,c.y) && b[c.x+1][c.y]==0) res.push_back(coord(c.x+1,c.y,0));
              if(valid(c.x,c.y-1) && b[c.x][c.y-1]==0) res.push_back(coord(c.x,c.y-1,0));
              if(valid(c.x,c.y+1) && b[c.x][c.y+1]==0) res.push_back(coord(c.x,c.y+1,0));
              return res;
              } 

void update(coord &c){
    vector<coord> nei = get_av_neigh(c);
    for(int i=0;i<nei.size();i++)
    if(a[nei[i].x][nei[i].y]>=a[c.x][c.y]){c.d=5;return;}
    c.d=brvalid(c.x,c.y)-nei.size();
    }

coord check(coord c){
      if(c.d==0) return coord(-1,0,0);
      vector<coord> nei=get_av_neigh(c);
      int brv=brvalid(c.x,c.y);
      //cout << "agh " << brv << ' ' << nei.size() << endl;
      if(nei.size()==brv) return coord(-2,0,0);
      vector<coord> un = get_un(c);
      return un[0];
      }

int main(){
    scanf("%d %d",&n,&m);
    //cin >> n >> m;
    priority_queue<coord> q;
    printf("0 0 0\n");
    //cout << "0 0 0\n";
    int fr;cin >> fr;
    a[0][0]=fr;
    b[0][0]=1;
    q.push(coord(0,0,3));
    int k=1;
    while(k<=3050){
                   k++;
                   coord c=q.top();
                   q.pop();
                   coord next=check(c);
                   if(next.x==-1){
                                  printf("1 %d %d\n",c.x,c.y);
                                  //cout << 1 << ' ' << c.x << ' ' << c.y << endl;
                                  return 0;}
                   if(next.x==-2) continue;
                   printf("0 %d %d\n",next.x,next.y);
                   //cout << 0 << ' ' << next.x << ' ' << next.y << endl;
                   scanf("%d",&a[next.x][next.y]);
                   //cin >> a[next.x][next.y];
                   b[next.x][next.y]=1;
                   vector<coord> nei = get_av_neigh(next);
                   update(next);
                   q.push(next);
                   for(int i=0;i<nei.size();i++) {
                           update(nei[i]);
                           q.push(nei[i]);
                           }
                   }
    printf("1 %d %d\n",m-2,n-2);
    //cout << m-2 << ' ' << n-2 << endl;
    return 0;
}
