/*
TASK: msweeper
LANG: C++
*/
#include <cstdio>
#include <cstdlib>
#include <cmath>
#define SQR(a) ((a)*(a))
#define maxN 10050

typedef struct point {
        int x,y;
        } point;

int n,R;
point list[maxN];
int srt[maxN], stk[maxN], l;
int d,dd;

int ori(point a, point b, point c)
{return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y);}

int cmp(const void *a, const void *b)
{
    d = ori(list[srt[0]],list[*(int*)a],list[*(int*)b]);
    if (d != 0) return d<0;
    dd = (list[*(int*)a].x-list[srt[0]].x)*(list[*(int*)b].x-list[*(int*)a].x);
    if (dd != 0) return dd<0;
    return list[*(int*)a].y > list[*(int*)b].y;
}


void input()
{
     int i,j=0;
     scanf("%d%d",&n,&R);
     for (i=0;i<n;++i) {
         scanf("%d%d",&list[i].x,&list[i].y);
         if ((list[i].y < list[j].y) || (list[i].y == list[j].y && list[i].x < list[j].x)) j=i;
         srt[i]=i;
         }
     srt[0]=j; srt[j]=0;
     qsort(&srt[1],n-1,sizeof(int),cmp);
     //for (i=0;i<n;++i) printf("%d %d\n",list[srt[i]].x,list[srt[i]].y);
}

void solve()
{
     int i; double r=0.0;
     stk[l++] = srt[0]; stk[l++] = srt[1];
     for (i=2;i<n;++i) {
         while (l>=2 && ori(list[stk[l-2]],list[stk[l-1]],list[srt[i]]) <= 0) --l;
         stk[l++] = srt[i];
         }
     //printf("~~~~~~\n");
     //for (i=0;i<l;++i) printf("%d %d\n",list[stk[i]].x,list[stk[i]].y);
     stk[l++] = stk[0];
     for (i=0;i<l-1;++i) r += sqrt(SQR(list[stk[i]].x-list[stk[i+1]].x)+SQR(list[stk[i]].y-list[stk[i+1]].y));
     r += 2.0*M_PI*(double)R;
     printf("%lf\n",r);
}

int main()
{
    input();
    solve();
    return 0;
}
