/*
TASK: titanic
LANG: C++
*/
#include <cstdio>
#include <vector>
using namespace std;

typedef struct point {
        int x,y;
        } point;
        
int n,m;
int A[1024][1024];
char used[1024][1024];

point makep(int x, int y)
{point r;r.x=x;r.y=y; return r;}

void ask(int x, int y)
{
     printf("0 %d %d\n",x-1,y-1); fflush(stdout);
     scanf("%d",&A[x][y]);
     used[x][y]=1;
}

char goodx(int p) {return(p>=1&&p<=n);}
char goody(int p) {return(p>=1&&p<=m);}

void bfs(point p)
{
     vector <point> q[2];
     int i,c=0;
     q[0].push_back(p);
     ask(p.x,p.y);
     
     while (1) {
           q[!c].clear();
           if (q[c].size() == 0) {printf("opa\n");return;}
           for (i=0;i<q[c].size();++i) {
               p = q[c][i];
               if (!used[p.x+1][p.y] && goodx(p.x+1)) {ask(p.x+1,p.y); q[!c].push_back(makep(p.x+1,p.y));}
               if (!used[p.x][p.y-1] && goody(p.y-1)) {ask(p.x,p.y-1); q[!c].push_back(makep(p.x,p.y-1));}
               if (!used[p.x-1][p.y] && goodx(p.x-1)) {ask(p.x-1,p.y); q[!c].push_back(makep(p.x-1,p.y));}
               if (!used[p.x][p.y+1] && goody(p.y+1)) {ask(p.x,p.y+1); q[!c].push_back(makep(p.x,p.y+1));}
               if (A[p.x][p.y]>A[p.x+1][p.y] && A[p.x][p.y]>A[p.x-1][p.y] && A[p.x][p.y]>A[p.x][p.y+1] && A[p.x][p.y]>A[p.x][p.y-1]) {
                  printf("1 %d %d\n",p.x-1,p.y-1); return;}
               }
           c = !c;
           }
}

int main()
{
    point p;
    scanf("%d%d",&n,&m);
    p.x = n/2; p.y = m/2;
    if (p.x == 0) ++p.x;  if (p.y == 0) ++p.y;
    bfs(p);
    return 0;
}
