/*
TASK: titanic
LANG: C++
*/
#include <iostream>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#define GR_1 500
#define GR_2 11
#define GR_3 300
using namespace std;

int K1;
int K = 3050;

int Vs[1024][1024];

int M,N;

void pfs(int i, int j)
{
    int mx=Vs[i][j], mi=-1, mj=-1;
    if(i!=0) {
             if(K1==GR_1) {return;}
             if(!Vs[i-1][j]) {
               K1++;
               printf("0 %d %d\n", i-1, j);
               scanf("%d", &Vs[i-1][j]);}
             //cout<<"0 "<<i-1<<" "<<j<<endl;
             //cin>>Vs[i-1][j];
             if(Vs[i-1][j]==0) {Vs[i-1][j]--;}
             if(mx<Vs[i-1][j]) {mi=i-1; mj=j;}
    }
    if(j!=0&&!Vs[i][j-1]) {
             if(K1>=GR_1) {return;}
             if(!Vs[i][j-1]) {
               K1++;
               printf("0 %d %d\n", i, j-1);
               scanf("%d", &Vs[i][j-1]);}
             //cout<<"0 "<<i<<" "<<j-1<<endl;
             //cin>>Vs[i][j-1];
             if(Vs[i][j-1]==0) {Vs[i][j-1]--;}
             if(mx<Vs[i][j-1]) {mi=i; mj=j-1;}
    }
    if(i!=N-1&&!Vs[i+1][j]) {
             if(K1>=GR_1) {return;}
             if(!Vs[i+1][j]) {
               K1++;
               printf("0 %d %d\n", i+1, j);
               scanf("%d", &Vs[i+1][j]);}
             //cout<<"0 "<<i+1<<" "<<j<<endl;
             //cin>>Vs[i+1][j];
             if(Vs[i+1][j]==0) {Vs[i+1][j]--;}
             if(mx<Vs[i+1][j]) {mi=i+1; mj=j;}
    }
    if(j!=M-1&&!Vs[i][j+1]) {
             if(K1>=GR_1) {return;}
             if(!Vs[i][j+1]) {
               K1++;
               printf("0 %d %d\n", i, j+1);
               scanf("%d", &Vs[i][j+1]);}
             //cout<<"0 "<<i<<" "<<j+1<<endl;
             //cin>>Vs[i][j+1];
             if(Vs[i][j+1]==0) {Vs[i][j+1]--;}
             if(mx<Vs[i][j+1]) {mi=i; mj=j+1;}
    }
    if(mi==-1&&mj==-1) {cout<<"1 "<<i<<" "<<j<<endl; exit(0);}
    pfs(mi,mj);
}

void pfs2(int i, int j)
{
    int mx=Vs[i][j], mi=-1, mj=-1;
    if(i!=0) {
             //if(K1==GR_1) {return;}
             //K1++;
             if(!Vs[i-1][j]){
             printf("0 %d %d\n", i-1, j);
             scanf("%d", &Vs[i-1][j]);}
             //cout<<"0 "<<i-1<<" "<<j<<endl;
             //cin>>Vs[i-1][j];
             if(Vs[i-1][j]==0) {Vs[i-1][j]--;}
             if(mx<Vs[i-1][j]) {mi=i-1; mj=j;}
    }
    if(j!=0) {
             //if(K1>=GR_1) {return;}
             //K1++;
             if(!Vs[i][j-1]){
             printf("0 %d %d\n", i, j-1);
             scanf("%d", &Vs[i][j-1]);}
             //cout<<"0 "<<i<<" "<<j-1<<endl;
             //cin>>Vs[i][j-1];
             if(Vs[i][j-1]==0) {Vs[i][j-1]--;}
             if(mx<Vs[i][j-1]) {mi=i; mj=j-1;}
    }
    if(i!=N-1) {
             //if(K1>=GR_1) {return;}
             //K1++;
             if(!Vs[i+1][j]){
             printf("0 %d %d\n", i+1, j);
             scanf("%d", &Vs[i+1][j]);}
             //cout<<"0 "<<i+1<<" "<<j<<endl;
             //cin>>Vs[i+1][j];
             if(Vs[i+1][j]==0) {Vs[i+1][j]--;}
             if(mx<Vs[i+1][j]) {mi=i+1; mj=j;}
    }
    if(j!=M-1) {
             //if(K1>=GR_1) {return;}
             //K1++;
             if(!Vs[i][j+1]){
             printf("0 %d %d\n", i, j+1);
             scanf("%d", &Vs[i][j+1]);}
             //cout<<"0 "<<i<<" "<<j+1<<endl;
             //cin>>Vs[i][j+1];
             if(Vs[i][j+1]==0) {Vs[i][j+1]--;}
             if(mx<Vs[i][j+1]) {mi=i; mj=j+1;}
    }
    if(mi==-1&&mj==-1) {cout<<"1 "<<i<<" "<<j<<endl; exit(0);}
}

int request(int i, int j)
{
    static int res;
    printf("0 %d %d\n", i, j);
    scanf("%d", &res);
    return res;
}

int main()
{
    size_t stt = clock();
    scanf("%d %d", &N, &M);
    printf("0 %d %d\n", N/2, M/2);
    scanf("%d", &Vs[N/2][M/2]);
    if(Vs[N/2][M/2]==0) {Vs[N/2][M/2]--;}
    /*cout<<"0 "<<N/2<<" "<<M/2<<endl;
    cin>>Vs[N/2][M/2];*/
    pfs(N/2,M/2);
    size_t ent = clock();
    K-=GR_1;
    if(1.0*(ent-stt)/CLOCKS_PER_SEC<0.15) {
       //greedy2();
    }
    srand(clock());
    for(int e = 0; e<K/5; e++)
    {
            int u = rand()%N, r = rand()%M;
            if(Vs[u][r]) {e--; continue;}
            Vs[u][r] = request(u,r);
            pfs2(u,r);
            ent = clock();
            if(1.0*(ent-stt)/CLOCKS_PER_SEC<0.15) {break;}
    }
    int mx=-1, mi=-1, mj=-1;
    for(int i=0; i<N; i++)
    {
            for(int j=0; j<M; j++)
            {
                    if(mx<Vs[i][j]) {mi=i;mj=j;mx=Vs[i][j];}
            }
    }
    cout<<"1 "<<mi<<" "<<mj<<endl;
}
