/*
TASK: frogs
LANG: C++
*/

#include <cstdio>
#include <algorithm>

const int MAX_N = 930000 + 5;

int N;
int h[MAX_N];
int j[MAX_N];

int cur[MAX_N];
int ans[MAX_N];
int top;

void make(int l, int r)
{
//	printf("%d %d\n", l, r);
	top = 0;
	cur[top ++] = - h[r];
	ans[r] = -1;
	for(int i = r - 1; i >= l; i --)
	{
		if( cur[top - 1] < -h[i] )
			cur[top ++] = -h[i];
		else
		{
			int pos = std :: lower_bound(cur, cur + top, -h[i]) - cur;
			top = pos + 1;
			cur[pos] = -h[i];
		}
		if( j[i] > top - 1 )	ans[i] = -1;
		else					ans[i] = - cur[top - j[i] - 1];
	}
}

int main()
{
	scanf("%d", &N);
	for(int i = 0; i < N; i ++)	scanf("%d", &h[i]);
	for(int i = 0; i < N; i ++)	scanf("%d", &j[i]);
	int r = N - 1;
	int mx = 0;
	int l = r - 1;
	while(r >= 0)
	{
		mx = h[r];
		while(l >= 0 && h[l] < mx)
		{
			if(h[l] > mx)	mx = h[l];
			l --;
		}
		make(l + 1, r);
		r = l;
		l = r - 1;
	}
	printf("%d", ans[0]);
	for(int i = 1; i < N; i ++)	printf(" %d", ans[i]);
	printf("\n");
	return 0;
}
