/*
TASK: special
LANG: C++
*/

#include <cstdio>
#include <string>
#include <set>

class cmp
{
	public:
	bool operator() (const std :: string &a, const std :: string &b)
	{
		return a.size() == b.size() ? a < b : a.size() < b.size();
	}
};

std :: set<std :: string, cmp> s;

const int iter = 10;

void gen79()
{
	std :: string t = "7";
	for(int nine = 0; nine < 3 * iter; nine ++, t = "9" + t)
	{
		std :: string cur = t;
		for(int zero = 0; zero < 3 * iter; zero ++, cur = cur + "0")
			s.insert(cur);
	}
	s.erase("7");
}

void gen3148()
{
	std :: string t = "3148";
	for(int zero = 0; zero < 3 * iter; zero ++, t += "0")
		s.insert(t);
}

void gen12()
{
	for(int mid = 0; mid < 2 * iter; mid ++)
		for(int last = 0; last < 3 * iter; last ++)
			s.insert( "2" + std :: string(mid, '0') + "1" + std :: string(mid, '0') + "2" + std :: string(last, '0') );
	s.erase("212");
}

void gen30wtf()
{
	std :: string t = "3074003";
	for(int last = 0; last < 2 * iter; last ++, t += "0")
		s.insert(t);
}

int N;
int main()
{
	scanf("%d", &N);
	gen12();
	gen79();
	gen3148();
	gen30wtf();
	int i = 0;
//	for(typeof(s.begin()) it = s.begin(); it != s.end() && i < 260; it ++, i ++)	printf("%s\n", it -> c_str());
	std :: set<std :: string, cmp> :: iterator it;
	for(it = s.begin(); it != s.end() && i < N; it ++, i ++);
	-- it;
	printf("%s\n", it -> c_str());
//	printf("size = %d\n", s.size());
	return 0;
}
