/*
TASK: diamonds
LANG: C++
*/
#include <cstdio>

int a[128][128][128];

int get(int x1, int y1, int z1, int x2, int y2, int z2)
{
	int res=a[x2][y2][z2];
	res-=a[x2][y2][z1]+a[x2][y1][z2]+a[x1][y2][z2];
	res+=a[x2][y1][z1]+a[x1][y2][z1]+a[x1][y1][z2];
	res-=a[x1][y1][z1];
	return res;
}

int main()
{
	int l, m, n;
	scanf("%d%d%d", &l, &m, &n);
	
	int i, j, k;
	for(i=1; i<=n; i++)
		for(j=1; j<=m; j++)
			for(k=1; k<=l; k++)
			{
				scanf("%d", &a[i][j][k]);
				a[i][j][k]+=a[i-1][j][k]+a[i][j-1][k]+a[i][j][k-1];
				a[i][j][k]-=a[i][j-1][k-1]+a[i-1][j][k-1]+a[i-1][j-1][k];
				a[i][j][k]+=a[i-1][j-1][k-1];
			}
	
	int x1, y1, z1, x2, y2, z2;
	while(scanf("%d%d%d%d%d%d", &x1, &y1, &z1, &x2, &y2, &z2)!=EOF)
		printf("%d\n", get(z1, y1, x1, z2, y2, x2));
	
	return 0;
}
