/*
TASK:frogs
LANG:C++
*/

#include <cstdio>
using namespace std;
const int NUM_FROGS = 1000000;

int h[NUM_FROGS];
int jmp[NUM_FROGS];
int prev[NUM_FROGS];

int main(){
    int n;
    scanf("%d", &n);
    
    for(int i = 0; i < n; i++)
            scanf("%d", h+i);
    for(int i = 0; i < n; i++)
            scanf("%d", jmp+i);
            
            
    for(int i = n-1; i > -1; i--){
        int j = i + 1;
        while( j < n && h[i] > h[j])
               j++;
        if(j == n){ 
             prev[i] = -1;
             jmp[i] = -1;
        }
        else{
            prev[i] = j;
            int ch;
            j = i;
            while( jmp[i] && j != -1){
                   j = prev[j]; 
                   ch = h[j];
                   jmp[i] --;
            }
            jmp[i] = j == -1? j : ch;
        }
                    
    }
    
    for(int i = 0; i < n-1; i++)
            printf("%d ", jmp[i]);
    printf("%d\n" ,jmp[n-1]);
    return 0;   
}
