/*
TASK: diamonds
LANG: C++
*/
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <stack>
#include <cmath>
#include <time.h>
#include <iomanip>
#include <stdio.h>
using namespace std;
#define DEBUG true
#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define FORB(i,a,b) for(int i = a; i >= b; i--)
#define FORE(v,f) for_each(v,f);
#define FORV(v,i) for(int i = 0; i < v.size(); i++)
#define SHOWV(v) if(DEBUG) for(int tmp0 = 0; tmp0 <= v.size(); tmp0++) cout << #v << "[" << tmp0 << "] = " << v[tmp0] << endl;
#define ALL(v) v.begin(), v.end()
#define PB push_back
#define LL long long
#define PII pair<int, int>
#define LD long double
#define SZ size()
#define VI vector<int>
#define VD vector<double>
#define SHOW(v) if(DEBUG) cout << #v << " = " << v << endl;
#define X first
#define Y second
#define PAUSE if(DEBUG) system("pause");
#define SHOWA(a,i) if(DEBUG) for(int tmp0 = 0; tmo0 <= i; tmp0++) cout << #a << "[" << tmp0 << "] = " << a[tmp0] << endl; 
#define TRANSF(v,f) transform(ALL(v), v.begin(), f);
#define SORT(v) sort(ALL(v));
#define MMAX 2147483647
#define MMIN -2147483647
#define MAXN 128
// variables
LL C[MAXN][MAXN][MAXN] = {0};
LL DP[MAXN][MAXN][MAXN] = {0};
int N, L, M;
int main()
{
    cin >> L >> M >> N;
    FOR(n,1,N)
        FOR(m,1,M)
            FOR(l,1,L)
            {
                cin >> C[n][m][l];
            }
    // do DP
    FOR(n,1,N+1)
        FOR(m,1,M+1)
            FOR(l,1,L+1)
                //DP[n][m][l] += DP[n][m][l-1] + DP[n][m-1][l] - DP[n][m-1][l-1] + C[n][m][l];
                DP[n][m][l] += DP[n-1][m][l] + DP[n][m-1][l] + DP[n][m][l-1]
                    + DP[n-1][m-1][l-1]
                    - DP[n][m-1][l-1] - DP[n-1][m][l-1] - DP[n-1][m-1][l]
                    + C[n][m][l];
    // read questions
    /*
    FOR(n,1,N)
    {
        FOR(m,1,M)
        {
            FOR(l,1,L)
                cout << DP[n][m][l] << " ";
            cout << endl;
        }
        cout << endl << endl;
    }
    */
    while(!cin.eof())
    {
        int x1 = -1,y1 = -1,z1 = -1,x2 = -1,y2 = -1,z2 = -1;
        cin >> x1 >> y1 >> z1 >> x2 >> y2 >> z2;
        if (z2 > -1) cout << DP[z2][y2][x2] - DP[z1][y1][x1] << endl;
    }
    return 0;
}
