/*
TASK: frogs
LANG: C++
*/

#include <cstdio>
#include <vector>

int n;
int cur, prev, last;
std::vector <int> h, next;

int main() {
//	freopen("frogs.in", "r", stdin);
//	freopen("frogs.out", "w", stdout);

	scanf("%d", &n);
	next.resize(n, 0);
	h.resize(n, 0);
	
	for(int i = 0; i < n; ++i) {
		scanf("%d", &h[i]);
	}

	next[n-1] = -1;

	for(int i = n-2; i >= 0; --i) {
		int j;
		for(j = i+1; h[i] >= h[j]; j = next[j]) {
			if(j == -1) {
				break;
			}
		}

		next[i] = j;
	}

	for(int i = 0; i < n; ++i) {
		scanf("%d", &cur);
		if(i)
			printf(" ");
		
		int res = i;
        for(int j = 0; j < cur && res != -1; res = next[res], ++j);
        
        printf("%d", res == -1 ? res : h[res]);
	}
	printf("\n");


	return 0;
}
