/*
TASK: diamonds
LANG: C++
*/

#include <iostream>
using namespace std;

int l, m, n;
long t[128][128][128];

void addT( int x, int y, int z, int p )
{
     for ( int i = x; i <= n; i=i+(i&(-i)) )
         for ( int j = y; j <= m; j = j+(j&(-j)) )
             for ( int k = z; k <= l; k = k + (k&(-k)) )
             {
                 t[i][j][k] = t[i][j][k] + p;
             }
}

long get( int x, int y, int z )
{
     long sum = 0;
     
     for ( int i = z; i > 0; i=i&(i-1) )
         for ( int j = y; j > 0; j = j&(j-1) )
             for ( int k = x; k > 0; k = k&(k-1) )
             {
                 sum = sum + t[i][j][k];
             }
     
     return sum;
}

long getAns( int x1, int y1, int z1, int x2, int y2, int z2 )
{
     long res;
     res = get( x2, y2, z2 ) + get( x1, y1, z2 ) + get( x2, y1, z1 ) + get( x1, y2, z1 ) - get( x2, y2, z1 ) - get( x2, y1, z2 ) - get(x1, y2, z2) + get( x1, y1, z1 );
     return res;
}

int main()
{
    int i, j, k, p;
    int x, y, z;
    
    scanf( "%d%d%d", &l, &m, &n );
    for ( i = 1; i <= n; i++ )
    {
        for ( j = 1; j <= m; j++ )
        {
            for ( k = 1; k <= l; k++ )
            {
                scanf( "%d", &p );
                addT( i, j, k, p );
            }
        }
    }
    
    while ( cin >> i >> j >> k >> x >> y >> z )
    {
          printf( "%d\n", getAns( i, j, k, x, y, z ) );
    }
    return 0;
}
