/*
TASK: diamonds
LANG: c++
*/
#include <iostream>
using namespace std;
struct point
{
    int x, y, z;
};
const int MAXL = 100, MAXM = 100, MAXN = 100;
int l, m, n, c[MAXL + 1][MAXM + 1][MAXN + 1], sum[MAXL + 1][MAXM + 1][MAXN + 1];
int d(point a, point b)
{
    int i, temp = 0;
    for(i = a.x; i <= b.x; i++)
        temp += sum[i][b.y][b.z] + sum[i][a.y - 1][a.z - 1] - sum[i][a.y - 1][b.z] - sum[i][b.y][a.z - 1];
    return temp;
}
int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int i, j, k;
    point a, b;
    cin >> l >> m >> n;
    for(i = 1; i <= n; i++)
        for(j = 1; j <= m; j++)
            for(k = 1; k <= l; k++)
                cin >> c[i][j][k];
    for(i = 1; i <= l; i++)
        for(j = 1; j <= m; j++)
            for(k = 1; k <= n; k++)
                sum[i][j][k] = c[k][j][i] + sum[i][j - 1][k] + sum[i][j][k - 1] - sum[i][j - 1][k - 1];
    while(1)
    {
        cin >> a.x >> a.y >> a.z >> b.x >> b.y >> b.z;
        if(cin.eof())
            break;
        a.x++;
        a.y++;
        a.z++;
        cout << d(a, b) << endl;
    }
    return 0;
}
