/*
TASK:DIAMONDS
LANG:C
*/
#include <stdio.h>
#include <stdlib.h>
#define DIM_SIZE 128
 
unsigned int diam[DIM_SIZE][DIM_SIZE][DIM_SIZE];


inline void add(int x,int y,int z,int val)
{
	int i,j,k;
	for(i=x;i<DIM_SIZE;i+=i&(-i))
		for(j=y;j<DIM_SIZE;j+=j&(-j))
			for(k=z;k<DIM_SIZE;k+=k&(-k))
				diam[i][j][k]+=val;
}
inline int get(int x,int y,int z)
{
	int i,j,k;
	int rez=0;
	for(i=x;i>0;i-=i&(-i))
		for(j=y;j>0;j-=j&(-j))
			for(k=z;k>0;k-=k&(-k))
				rez+=diam[i][j][k];
	return rez;
}
#define GET(x1,y1,z1,x2,y2,z2) (get(x2,y2,z2)\
-get(x1,y2,z2)-get(x2,y1,z2)-get(x2,y2,z1)\
+get(x2,y1,z1)+get(x1,y2,z1)+get(x1,y1,z2)\
-get(x1,y1,z1))

int main()
{
	int i,j,k;
	int a,b,c;
	int M,n,l;
	scanf("%d%d%d",&l,&M,&n);
	for(k=1;k<=n;++k)
		for(j=1;j<=M;++j)
			for(i=1;i<=l;++i)
			{
				scanf("%d",&a);
				add(i,j,k,a);
			}
	while(scanf("%d%d%d%d%d%d",&a,&b,&c,&i,&j,&k)>0)
		printf("%d\n",GET(a,b,c,i,j,k));
	//system("pause");
	return 0;
}
