/*
TASK:FROGS
LANG:C
*/
#include <stdio.h>
#define MAXN 1000000
#define M 2
#define MOD 1024
#define H(a) (a!=NULL?(a->h):-1)
struct frg
{
	unsigned int h;
	union
	{
		struct frg* next[M];
		struct frg* prev;
	};
}frogs[MAXN];

int main()
{
	struct frg* last=NULL,*tmp;
	int n;
	int i,j,x;
//	printf("%d",(sizeof(frogs)+sizeof(last)+sizeof(tmp)+sizeof(n)+sizeof(i)+sizeof(j)+sizeof(x))/1024);
	scanf("%d",&n);
	for(i=0;i<n;++i)
	{
		scanf("%d",&(frogs[i].h));
		while(last!=NULL&&last->h<frogs[i].h)
		{
			tmp=last;
			last=last->prev;
			tmp->next[0]=frogs+i;
		}
		frogs[i].prev=last;
		last=frogs+i;
	}
	while(last!=NULL)
	{
		tmp=last->prev;
		last->next[0]=NULL;
		last=tmp;
	}
	for(x=1;x<M;++x)
		for(i=n-1;i>-1;--i)
		{
			tmp=frogs+i;
			for(j=0;j<MOD&&tmp!=NULL;++j)
				tmp=tmp->next[x-1];
			frogs[i].next[x]=tmp;
		}
	for(i=0;i<n;++i)
	{
		scanf("%d",&x);
		tmp=frogs+i;
//		printf("(%d %d %d) ",tmp->next[0]-frogs,tmp->next[1]-frogs,tmp->next[2]-frogs);
		for(j=0;j<M;++j)
		{
			while(x%MOD!=0&&tmp!=NULL)
			{
				--x;
				tmp=tmp->next[j];
	//			printf("*");
			}
			if(tmp==NULL)
				break;
			x/=MOD;
//			printf("|");
		}
//		printf("\n");
		if(i==n-1)
			printf("%d\n",H(tmp));
		else
			printf("%d ",H(tmp));
	}
	return 0;
}
