/*
TASK: diamonds
LANG: C++
*/

#include <iostream>
#include <stdio.h>

using namespace std;

//     L    M    N
int t[101][101][101];
int l,m,n;

void add(int x, int y, int z, int val) {
  
  //t[x][y][z];
  for(int k=z;k<=n;k+=k&(-k)) {
    for(int i=x;i<=l;i+=i&(-i)){
      for(int j=y;j<=m;j+=j&(-j)) {
        t[i][j][k] += val;
      }
    }
  }
  
}

int get(int x, int y, int z) {
  int res=0;
  
  for(int k=z;k>0;k-=k&(-k)) {
    for(int i=x;i>0;i-=i&(-i)) {
      for(int j=y;j>0;j-=j&(-j)) {
        res += t[i][j][k];
      }
    }
  }
  
  return res;
}

int main() {
  scanf("%d %d %d", &l, &m, &n);
  int tmp;
  
  for(int i=1;i<=n;i++)
    for(int j=1;j<=m;j++)
      for(int k=1;k<=l;k++) {
        scanf("%d", &tmp);
        add(k,j,i,tmp);
      }

//   for(int i=1;i<=n;i++) {
//     for(int j=1;j<=m;j++) {
//       for(int k=1;k<=l;k++)
//         cout<<t[k][j][i]<<" ";
//       cout<<endl;
//     }
//     cout<<endl<<endl;
//   }
  
//   cout<<_get(l,m-1,2)<<endl;
  int sum,x1,y1,z1,x2,y2,z2;
      
  while(cin>>x1>>y1>>z1>>x2>>y2>>z2) {
    sum=0;
    
    sum += get(x2,y2,z2);
//     cout<<sum<<" ";
    if(y1) {
      sum -= get(x2,y1,z2);
//       cout<<"y1:{"<<sum<<" ";
      if(z1) {
        sum += get(x2,y1,z1);
//         cout<<"z11:"<<sum<<" ";
      }
      if(x1) {
        sum += get(x1,y1, z2);
//         cout<<"x11:"<<sum<<" ";
      }
//       cout<<"} ";
    }
    
    if(x1) {
      sum -= get(x1, y2, z2);
//       cout<<"x12:{-:"<<sum<<" ";
      if(z1) {
        sum += get(x1,y2,z1);
//         cout<<"+:"<<sum<<" ";
        if(y1) {
          sum -= get(x1,y1,z1);
//           cout<<"--:"<<sum<<" ";
        }
      }
//       cout<<"} ";
    }
    if(z1) {
      sum -= get(x2,y2,z1); 
//       cout<<"z12:"<<sum<<"   ";
    }
    
    cout<<sum<<endl;
    
  }
  
  return 0;
}
