/*
TASK: frogs
LANG: C++
*/
#include <cstdio>

const int MAXN = 1 << 20;

int n;
int a[MAXN] , b[MAXN];
int ans[MAXN];

void read() {
	int i;
	
	scanf ( "%d" , &n );
	
	for (i = 1; i <= n; i ++)
		scanf ( "%d" , &a[i] );
				
	for (i = 1; i <= n; i++)
		scanf ( "%d" , &b[i] );
}

void solve() {
	int i , j;
	
	j = n + 1;
	for (i = n; i >= 1; i--) {
		while ( j != n + 1 && a[j] <= a[i] ) ++ j;
		a[ -- j ] = a[i];
		
		if ( j + b[i] > n )
			ans[i] = -1;
		else
			ans[i] = a[ j + b[i] ];
	}
	
	printf ( "%d" , ans[1] );
	for (i = 2; i <= n; i++)
		printf ( " %d" , ans[i] );
	printf ( "\n" );
}

int main() {
	read();
	solve();
	
	return 0;
}
