/*
TASK: diamonds
LANG: C++
*/
// Iordan Boev SMG
# include <stdio.h>
# include <iostream>
# include <vector>
# include <queue>
# include <algorithm>

using namespace std;

# define fi(A) for(int i = 0; i < A; i++)
# define fj(A) for(int j = 0; j < A; j++)
# define fk(A) for(int k = 0; k < A; k++)
# define repi(A,B) for(int i = A; i < B; i++)
# define repj(A,B) for(it j = A; j < B; j++) 
# define repk(A,B) for(int k = A; k < B; k++)
# define brepi(A,B) for(int i = A-1; i >= B; i--)
# define MAXN (105)

int n,m,l;
int tree[MAXN*2][MAXN*2][MAXN*2];
int val;
int wn,wm,wl;
int t1,t2;
int dvel,dvem,dven;
int x1,x2,y1,y2,z1,z2;

void add3(int L,int R,int p) {
    tree[t1][t2][p]+=val;
    if(L >= R) return;
    int mid = (L+R)/2;
    if(wn <= mid) {
        add3(L, mid, 2*p+1);
    } else {
        add3(mid+1,R,2*p+2);
    }
}

void add2(int L,int R,int p) {
    t2 = p;  
    add3(0,dven-1,0);
    if(L>=R) return;
    int mid = (L+R)/2;
    if(wm <= mid) {
        add2(L,mid,2*p+1);
    } else {
        add2(mid+1,R,2*p+2);
    }
}

void add1(int L, int R,int p) {
    t1 = p;
    add2(0,dvem-1,0);

    if(L >= R) {
        return;
    }
    int mid = (L+R)/2;
    if(wl <= mid) {
        add1(L,mid,2*p+1);
    } else {
        add1(mid+1,R,2*p+2);
    }
}

int ask3(int L,int R,int b,int p) {
    if(L > b) return 0;
    if(R <= b) return tree[t1][t2][p];
    return ask3(L, (L+R)/2, b,2*p+1) + ask3((L+R)/2+1,R, b,2*p+2);
}

int ask2(int L,int R,int b,int p) {
    if(L > b) return 0;
    if(R <= b) {
        t2 = p;
        return ask3(0,dven-1,z2-1,0) - ask3(0,dven-1,z1-1,0);
    }
    return ask2(L, (L+R)/2,b,2*p+1) + ask2((L+R)/2+1,R,b,2*p+2);
}

int ask1(int L,int R,int b,int p) {
    if(L > b) return 0;
    if(R <= b) {
        t1 = p;
        return (ask2(0,dvem-1,y2-1,0) - ask2(0,dvem-1,y1-1,0));
    }
    return ask1(L,(L+R)/2,b,2*p+1) + ask1((L+R)/2+1,R,b,2*p+2);
}

void read() {
    scanf("%d %d %d", &l, &m,&n);
    dvel = 1;
    while(dvel < l) dvel*=2;
    dvem = 1;
    while(dvem < m) dvem*=2;
    dven = 1;
    while(dven < n) dven*=2;
    fi(n) {
        fj(m) {
            fk(l) {
                scanf("%d", &val);
                wl = k;
                wn = i;
                wm = j;
                add1(0,dvel-1,0);
            }
        }
    }
    //scanf("\n");
    while( scanf("%d %d %d %d %d %d", &x1,&y1,&z1,&x2,&y2,&z2) == 6 ) {
        // L   x1.....x2
        // M   y1.....y2
        // N   z1.....z2
        int ans = ask1(0,dvel-1,x2-1,0) - ask1(0,dvel-1,x1-1,0);
        printf("%d\n", ans);
    }
    //printf("%d\n", tree[0][0][0]);
}

int main () {
    read();
    return 0;
}

