/*
TASK: frogs
LANG: C++
*/
// Iordan Boev
# include <stdio.h>
# include <iostream>
# include <vector>
# include <queue>
# include <algorithm>
# include <math.h>

using namespace std;

# define fi(A) for(int i = 0; i < A; i++)
# define fj(A) for(int j = 0; j < A; j++)
# define fk(A) for(int k = 0; k < A; k++)
# define repi(A,B) for(int i = A; i < B; i++)
# define repj(A,B) for(it j = A; j < B; j++) 
# define repk(A,B) for(int k = A; k < B; k++)
# define brepi(A,B) for(int i = A-1; i >= B; i--)
# define pb push_back
# define MAXF ((1<<18)+70000)

int n;
struct frog {
    int h, id;
} v[MAXF];
vector <int> j;
vector<int> height;
struct list {
    int next,prev;
} f[MAXF];
int follow[MAXF];
int ans[MAXF];
vector <int> lchain;

void read() {
    scanf("%d", &n);
    height.pb(0);
    repi(1,n+1) {
        scanf("%d", &v[i].h);
        v[i].id = i;
        height.pb(v[i].h);
        f[i].prev = i-1;
        f[i].next = i+1;
    }
    int tt=0;
    j.pb(tt);
    repi(1,n+1) {
        scanf("%d", &tt);
        j.pb(tt);
    }
}

int cmp(const void *e1,const void *e2) {
    if((((frog*)e1)->h) != (((frog*)e2)->h) )return (((frog*)e1)->h) - (((frog*)e2)->h);
    else return (((frog*)e2)->id) - (((frog*)e1)->id);
}

void cntnext() {
    qsort(v+1,n,sizeof(frog),cmp);
    /*repi(1,n+1) {
        printf("%d %d\n", v[i].h,v[i].id);
    }*/
    repi(1,n+1) {
        //smqtame za i-tiq
        int c = v[i].id;
        int s,p;
        s = f[c].next;
        p = f[c].prev;
        follow[c] = s;
        f[p].next = s;
        f[s].prev = p;
    }
    /*repi(1,n+1) {
        printf("%d ", follow[i]); 
    }*/
}

void makechain(int c) {
    vector <int> chain;
    chain.pb(c);
    int last = c;
    while( follow[last] < n+1) {
        last = follow[last];
        chain.pb(last);
    }
    last = chain.size();
    fi(last) {
        int cur = chain[i];
        if(ans[cur] != 0) continue;
        if(j[cur] >= last-i) {ans[cur] = -1; continue;}
        ans[cur] = height[chain[i+j[cur]]];
    }
    lchain = chain;
}

void solve() {
    cntnext();
    int madechain = -1;
    repi(1,n+1) {
        if(ans[i] != 0) madechain = -1;
        if(ans[i] == 0) {
            if(height[i] <= height[i-1] && madechain == 1) {
                if(height[i] == height[i-1]) {
                    ans[i] = ans[i-1];
                    continue;
                } else {
                    if(j[i] >= (int)lchain.size()) ans[i] = -1;
                    else {
                        ans[i] = height[lchain[j[i]]];
                    }
                    continue;
                }
            }
            madechain = 1;
            makechain(i);
        }
    }
    repi(1,n) printf("%d ", ans[i]); 
    printf("%d\n", ans[n]);
}

int main() {
    read();
    solve();
    return 0;
}
