/*
TASK: frogs
LANG: C++
*/
#include<stdio.h>
#define pii pair<int,int>
#define MAXN 1000001
#define LOOPSIZE 80000
#include<queue>
using namespace std;
int g[MAXN],n,h[MAXN],loop[MAXN]={0};
void init();
int DFS(int s,int j);
int main()
{
 int i,k,ans;
 init();
 for(i=0;i<n-1;i++)
 {
  scanf("%d",&k);
  ans=DFS(i,k);
  printf("%d ",ans);
 }
 scanf("%d",&k);
 ans=DFS(n-1,k);
 printf("%d\n",ans);
/* printf("\n");
 for(i=0;i<n;i++)
  printf("%d ",loop[i]);
  printf("\n");
 for(i=0;i<n;i++)
  printf("%d ",g[i]);
  printf("\n");
*/
 return 0;
}
void init()
{
 priority_queue <pii,vector<pii>,greater <pii> > pq;
 scanf("%d",&n);
 int i,j;
 pii tmp,inp;
 for(i=0;i<n;i++)
 { 
  scanf("%d",&h[i]);
  g[i]=-1;
  inp.first=h[i];
  inp.second=i;
  while(!pq.empty())
  {
   tmp=pq.top();
   if(tmp.first>inp.first)break;
   pq.pop();
   g[tmp.second]=inp.second;
  }
  pq.push(inp);
 }
 return; 
}
int DFS(int s,int j)
{
// printf("*****\n");
 int ans=h[s],S=s,k=0;
 for(;j;j--)
 {
  if(s==-1)break;
//  printf("k=%d j=%d s=%d S=%d loop[s]=%d\n",k,j,s,S,loop[s]);
  if(j>=LOOPSIZE && loop[s]){s=loop[s];j-=(LOOPSIZE);k=-1;}
  else {s=g[s];k++;}
  if(k==LOOPSIZE){loop[S]=s;S=s;k=-1;}
 }
 if(s==-1)ans=-1;
 else ans=h[s];
 return ans;
}
