/*
TASK: diamonds
LANG: C++
*/

#include <iostream>

using namespace std;

int l,n,m;
int indt[129][129][129];


void addt3(int n,int sum,int i, int j)
{
	while(n!=256)
	{
		indt[i][j][n]+=sum;
		n+=(n&(-n));
	}
}

void addt2(int n,int sum,int k,int i)
{
	while(n!=256)
	{
		addt3(k,sum,i,n);
		n+=(n&(-n));
	}
}

void addt1(int n,int sum,int j,int k)
{
	while(n!=256)
	{
		addt2(j,sum,k,n);
		n+=(n&(-n));
	}
}

int qrr3(int k,int i,int j)
{
	int sum=0;
	while(k)
	{
		sum+=indt[i][j][k];
		k-=(k&(-k));
	}
	return sum;
}

int qrr2(int j,int k,int i)
{
	int sum=0;
	while(j)
	{
		sum+=qrr3(k,i,j);
		j-=(j&(-j));
	}
	return sum;
}

int qrr1(int i,int j,int k)
{
	int sum=0;
	while(i)
	{
		sum+=qrr2(j,k,i);
		i-=(i&(-i));
	}
	return sum;
}

void read()
{
	int x;
	scanf("%d %d %d",&l,&m,&n);
	for(int i=1;i<=n;i++)
	{
		for(int j=1;j<=m;j++)
		{
			for(int k=1;k<=l;k++)
			{
				scanf("%d",&x);
				addt1(i,x,j,k);
			}
		}
	}
	int x1,y1,z1,x2,y2,z2;
	while(scanf("%d %d %d %d %d %d",&x1,&y1,&z1,&x2,&y2,&z2)!=EOF)
	{
		int ans=qrr1(z2,y2,x2);
		ans-=qrr1(z1,y2,x2);
		ans-=qrr1(z2,y2,x1);
		ans-=qrr1(z2,y1,x2);
		ans+=qrr1(z1,y1,x2);
		ans+=qrr1(z1,y2,x1);
		ans+=qrr1(z2,y1,x1);
		ans-=qrr1(z1,y1,x1);
		printf("%d\n",ans);
	}
}

int main()
{
	read();
	return 0;
}
