/*
TASK: diamonds
LANG: C++
*/
#include <stdio.h>
#define MAX (1 << 7)
using namespace std;

int n , m , l , it[MAX][MAX][MAX] , t;
int x1, x2, y1,y2 , z1, z2;

inline void updateZ (int x, int y , int z , int val)
{
 for ( ; z < MAX ; z += z & (-z) )
  it[x][y][z] += val; 
}

inline void updateY (int x , int y, int z , int val)
{
 for ( ; y < MAX ; y += y & (-y) )
  updateZ ( x , y , z , val ); 
}

inline void updateX (int x , int y , int z , int val)
{
 for ( ; x < MAX ; x += x & (-x) )
  updateY ( x , y , z , val );
}

inline int queryZ (int x , int y, int z)
{
 int ans = 0;
 for (; z ; z = z & (z-1) )
  ans += it[x][y][z];
 return ans ;
}

inline int queryY (int x, int y ,int z)
{
 int ans = 0;
 for (; y ; y = y & (y-1) )
  ans += queryZ ( x , y , z );
 return ans ;      
} 

inline int queryX (int x, int y, int z)
{
 int ans = 0;
 for (; x ; x = x & (x-1) )
  ans += queryY ( x , y , z );
 return ans ;
} 

int main ()
{
 scanf ("%d%d%d", &l , &m, &n);
 
 for (int i=1; i <= n; ++i)
  for (int j=1; j <= m; ++j) 
   for (int k=1; k <= l; ++k)
    scanf ("%d", &t) , updateX (k , j , i , t);
 
 while ( scanf ("%d%d%d%d%d%d", &x1, &y1, &z1, &x2, &y2, &z2) != -1 ) 
  printf ("%d\n", queryX (x2 , y2, z2) 
                - queryX (x2 , y2 , z1) - queryX (x2 , y1 , z2) - queryX (x1 , y2, z2)
                + queryX (x2 , y1 , z1) + queryX (x1 , y2 , z1) + queryX (x1 , y1, z2) 
                - queryX (x1 , y1 , z1) );
  
 return 0;    
}
