/*
TASK: diamonds
LANG: C++
*/
#include <cstdio>
#include <algorithm>
#include <sstream>
#include <string>
#include <iostream>
using namespace std;

const int MAX_N = 128;
const int MAX_M = 128;
const int MAX_L = 128;

int N, M, L;
int C[MAX_N][MAX_M][MAX_L];

int main(){
    scanf ("%d%d%d",&L,&M,&N);
    for(int i=1; i<=N; ++i) for(int j=1; j<=M; ++j) for(int k=1; k<=L; ++k) scanf ("%d",&C[i][j][k]);
    for(int i=1; i<=N; ++i) for(int j=1; j<=M; ++j) for(int k=1; k<=L; ++k) C[i][j][k] += C[i][j][k-1];
    for(int i=1; i<=N; ++i) for(int k=1; k<=L; ++k) for(int j=1; j<=M; ++j) C[i][j][k] += C[i][j-1][k];
    int l1,l2,m1,m2,n1,n2;
    int i, res;
    while( scanf ("%d%d%d%d%d%d",&l1,&m1,&n1,&l2,&m2,&n2) != -1 ){
           res = 0;
           for( i= n1+1 ; i<= n2 ; ++i ){
                res += C[i][m2][l2] + C[i][m1][l1] - C[i][m1][l2] - C[i][m2][l1];
                }
           printf ("%d\n",res);
           }
}
