/*
TASK: diamonds
LANG: C++
*/

#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

int idt[110][110][110];
int l,m,n;

void add(int i,int j,int k,int val)
{
 int pos,pos2;
 
 for(;i<=l;i+=i&(-i))
   for(pos=j;pos<=m;pos+=pos&(-pos))
       for(pos2=k;pos2<=n;pos2+=pos2&(-pos2))
           idt[i][pos][pos2]+=val;    
}

int srch(int i,int j,int k)
{
 int res=0;   
 int pos,pos2;
 
 for(;i>0;i-=i&(-i))
   for(pos=j;pos>0;pos-=pos&(-pos))
     for(pos2=k;pos2>0;pos2-=pos2&(-pos2))
         res+=idt[i][pos][pos2];   
 return res;
}

int main()
{
 scanf("%d %d %d",&l,&m,&n);
 int tmp;
 
 for(int i=1;i<=n;i++)
    for(int j=1;j<=m;j++)
       for(int k=1;k<=l;k++)
            { 
              scanf("%d",&tmp);
              add(k,j,i,tmp);
            }

 int x1,y1,z1,x2,y2,z2;
 int res=0;
 
 while(cin>>x1>>y1>>z1>>x2>>y2>>z2)
 {
 
  res=srch(x2,y2,z2);
  //cout<<res<<endl;
  res-=srch(x2,y2,z1);
  //cout<<res<<endl;
  res-=srch(x1,y2,z2);
  //cout<<res<<endl;
  res+=srch(x1,y2,z1);
  //cout<<res<<endl;
  res-=srch(x2,y1,z2);
  //cout<<res<<endl;
  res+=srch(x1,y1,z2);
  //cout<<res<<endl;
  res+=srch(x2,y1,z1);
  //cout<<res<<endl;
  res+=srch(x1,y1,z1);
  printf("%d\n",res);                                  
 }

 return 0;
}
