/*
TASK: diamonds
LANG: C++
*/

#include<iostream>
#define maxn 128
using namespace std;

int tree[128][128][128];
int L,M,N,SS;

inline int lb(int p)
{
 return p & (-p);
}

void insert(int x,int y,int z,int p)
{
 for(int i=x+1;i<maxn;i=i+lb(i))
  for(int j=y+1;j<maxn;j=j+lb(j))
   for(int k=z+1;k<maxn;k=k+lb(k))
    tree[i][j][k]=tree[i][j][k]+p;   
}

int query(int x,int y,int z)
{long long S=0;

 for(int i=x;i>0;i=i-lb(i))
  for(int j=y;j>0;j=j-lb(j))
   for(int k=z;k>0;k=k-lb(k))
    S=S+tree[i][j][k];
    
return S;
}

int main()
{
 cin>>N>>M>>L;
 
int p; 
 
  for(int i=1;i<=N;i++)
   for(int j=1;j<=M;j++)
    for(int k=1;k<=L;k++){
     scanf("%d",&p);
      insert(i,j,k,p);
     }
     
  int x1,y1,z1,x2,y2,z2;   
 while(1){
            scanf("%d %d %d %d %d %d",&x1, &y1, &z1, &x2, &y2, &z2);    
  long S=query(x2+1,y2+1,z2+1);
  long S1=query(x2+1,y1,z2+1); // -
  long s=query(x2+1,y2+1,x1+1); // -
  long s1=query(x1+1,y2,z2+1); // -
  long s2=query(x1+1,y2,z1+1); // + 
  long s3=query(x2,y2,z1); // +
  
   
     if(SS==S-(S1+s+s1) + s2 + s3) break;
      else SS=S-(S1+s+s1) + s2 + s3;
     
     SS=S-(S1+s+s1) + s2 + s3;
  
printf("%d\n", SS);  

}
return 0;
}      
